#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#if defined(STDC_HEADERS) && (STDC_HEADERS==1)
#include <stdlib.h>
#include <string.h>
#else
#include <strings.h>
#endif

/* #include <stdlib.h> */
/* #include "string.h" */
/*#include "defs.h" */
/*#include "SiDefines.h" */

/* #include "bif.h" */
/* #include "ll.h" */
/* #include "symb.h" */

#include <stdio.h>
#include <malloc.h>
#include "db.h"
#include "makespec.h"
/* #include "decl.h" */

#define NON 306

extern int atoi();
extern void exit();
extern void del_var_decl_son_list();
extern PTR_PROJ OpenProj();
extern void init_m();
extern void make_file_list(char *);
extern PTR_BFND makeProgram(PTR_FILE,PTR_SYMB);
extern int yyparse();

void transLlnd();
static void initBfnd();
static void initBlob();
static void initSymb();
static void initType();
static void initLlnd();
static int isretnstat();
static void pr_help();

PCF UnparseBlock[];

int debug;
enum SCOPE {
	in_proc,in_func};
enum SCOPE scope;
PTR_FILE cur_file,fi;

PTR_BFND  global_bfnd;
PTR_FNAME head_file,cur_thread_file;

adddecl(struct file_obj *fi)
{
	struct bfnd *bf,*temp_bf;
	struct blob *bl,*temp1_bl,*temp2_bl;
	struct symb *sy,*temp_sy;
	struct blob *stack[10];
	struct blob *stabp;
	struct data_type *ty,*temp_ty ;
	struct llnd *ll1,*ll2,*ll3,*temp_ll;

	int i,k;

	char *funame;
	char *addfuname1,*addfuname2,*addfuname3;

	i=0;
	if(fi->head_bfnd->entry.Template.bl_ptr1->next!=NULL)
	{
		temp1_bl=fi->head_bfnd->entry.Template.bl_ptr1->next;
		while(temp1_bl!=NULL)
		{
			stack[i]=temp1_bl;
			i=i+1;
			temp1_bl=temp1_bl->next;
		}
		i=i-1;

		for(k=0;k<=i;k=k+1)
		{
			stabp=stack[k];

			bf=(struct bfnd *)malloc(sizeof(struct bfnd));
			initBfnd(bf);
			bl=(struct blob *)malloc(sizeof(struct blob));
			initBlob(bl);
			sy=(struct symb *)malloc(sizeof(struct symb));
			initSymb(sy);
			ty=(struct data_type *)malloc(sizeof(struct data_type));
			initType(ty);
			ll1=(struct llnd *)malloc(sizeof(struct llnd));
			initLlnd(ll1);
			ll2=(struct llnd *)malloc(sizeof(struct llnd));
			initLlnd(ll2);
			ll3=(struct llnd *)malloc(sizeof(struct llnd));
			initLlnd(ll3);

			/* Creat BLOB */
			bl->next=NULL;
			bl->ref=bf;
			fi->num_blobs=fi->num_blobs+1;

			/* Creat BFND */
			bf->variant=VAR_DECL;
			bf->id=fi->num_bfnds+1;
			fi->num_bfnds=fi->num_bfnds+1;
			bf->entry.Template.ll_ptr1=ll2;
			bf->entry.Template.ll_ptr2=ll3;
			temp_bf=fi->head_bfnd;
			while(temp_bf->thread!=NULL)
			{
				temp_bf=temp_bf->thread;
			}
			temp_bf->thread=bf;
			bf->thread=NULL;

			/* creat LLND llnd1 */
			ll1->variant=VAR_REF;
			ll1->id=fi->num_llnds+1;
			fi->num_llnds=fi->num_llnds+1;
			ll1->entry.Template.symbol=sy;
			temp_ll=fi->head_llnd;
			while(temp_ll->thread!=NULL)
			{
				temp_ll=temp_ll->thread;
			}
			temp_ll->thread=ll1;
			ll1->thread=NULL;

			/* creat LLND llnd2 */
			ll2->variant=EXPR_LIST;
			ll2->id=fi->num_llnds+1;
			fi->num_llnds=fi->num_llnds+1;
			ll2->entry.Template.ll_ptr1=ll1;
			temp_ll=fi->head_llnd;
			while(temp_ll->thread!=NULL)
			{
				temp_ll=temp_ll->thread;
			}
			temp_ll->thread=ll2;
			ll2->thread=NULL;

			/* Creat LLND llnd3 */
			ll3->variant=TYPE_OP;
			ll3->id=fi->num_llnds+1;
			fi->num_llnds=fi->num_llnds+1;
			ll3->type=ty;
			temp_ll=fi->head_llnd;
			while(temp_ll->thread!=NULL)
			{
				temp_ll=temp_ll->thread;
			}
			temp_ll->thread=ll3;
			ll3->thread=NULL;

			/* Creat SYMB */
			sy->variant=VARIABLE_NAME;
			sy->id=fi->num_symbs+1;
			fi->num_symbs=fi->num_symbs+1;
			sy->type=ty;
			funame=stabp->ref->entry.Template.symbol->ident;
			sy->ident=(char *)malloc(36);
			/*strcpy(sy->ident,funame);
addfuname1=" ";
strcat(sy->ident,addfuname1);
addfuname2=(char *)malloc(25);
strcpy(addfuname2,funame);
addfuname1="o";
strcat(addfuname2,addfuname1);
strcat(sy->ident,addfuname2);*/
			strcpy(sy->ident,funame);
			addfuname1=" ";
			strcat(sy->ident,addfuname1);
			addfuname2=(char *)malloc(25);
			funame=stabp->ref->entry.Template.bl_ptr1->ref->entry.Template.symbol->ident;
			addfuname1="_o";
			strcpy(addfuname2,funame);
			strcat(addfuname2,addfuname1);
			strcat(sy->ident,addfuname2);

			temp_sy=fi->head_symb;
			while(temp_sy->thread!=NULL)
			{
				temp_sy=temp_sy->thread;
			}
			temp_sy->thread=sy;
			sy->thread=NULL;

			/* Creat TYPE */

			ty->variant=DEFAULT;
			ty->id=fi->num_types+1;
			fi->num_types=fi->num_types+1;
			temp_ty=fi->head_type;
			while(temp_ty->thread!=NULL)
			{
				temp_ty=temp_ty->thread;
			}
			temp_ty->thread=ty;
			ty->thread=NULL;

			/* add VAR_DECL bfnd */
			temp2_bl=fi->head_bfnd->entry.Template.bl_ptr1;
			while(temp2_bl->ref->variant!=PROG_HEDR)
			{
				if(temp2_bl->ref->variant==FUNC_HEDR)
				{
					return;
				}
				else
				{
					;
				}
				temp2_bl=temp2_bl->ref->entry.Template.bl_ptr1;
			}
			bl->next=temp2_bl->ref->entry.Template.bl_ptr1;
			temp2_bl->ref->entry.Template.bl_ptr1=bl;


		} /* forend */

	} /* ifend */
	/* Here give information about FUNCTION node */
	/* else
{ 
 printf("There are some subroutines\n");
 printf("I'm sorry for work about subroutines\n");  
} */

}

addclassp(struct file_obj *fi)
{
	struct bfnd *bf,*temp_bf;
	struct blob *bl;
	struct symb *sy,*temp_sy;
	struct blob *stack[10];
	struct blob *stabp;
	struct data_type *ty,*temp_ty ;
	char *proname;
	char *p1,*p2;

	bf=(struct bfnd *)malloc(sizeof(struct bfnd));
	bl=(struct blob *)malloc(sizeof(struct blob));
	sy=(struct symb *)malloc(sizeof(struct symb));
	ty=(struct data_type *)malloc(sizeof(struct data_type));

	initBfnd(bf);
	initBlob(bl);
	initSymb(sy);
	initType(ty);

	/* Creat BLOB */
	bl->next=NULL;
	bl->ref=NULL;
	fi->num_blobs=fi->num_blobs+1;

	/* Creat BFND */
	bf->variant=CLASS_DECL;
	bf->id=fi->num_bfnds+1;
	fi->num_bfnds=fi->num_bfnds+1;

	bf->entry.Template.symbol=sy;
	bf->entry.Template.bl_ptr1=bl;
	bf->entry.Template.ll_ptr1=bf->entry.Template.ll_ptr2=bf->entry.Template.ll_ptr3=NULL;

	temp_bf=fi->head_bfnd;
	while(temp_bf->thread!=NULL)
	{
		temp_bf=temp_bf->thread;
	}
	temp_bf->thread=bf;
	bf->thread=NULL;

	/* Creat SYMB */
	sy->variant=CLASS_NAME;
	sy->id=fi->num_symbs+1;
	sy->entry.func_decl.num_input=0;
	sy->entry.func_decl.num_output=0;
	sy->entry.func_decl.num_io=0;
	fi->num_symbs=fi->num_symbs+1;
	sy->type=ty;
	/* get proname */
	sy->ident=(char *)malloc(15);
	p2=(char *)malloc(15);
	p2="               ";
	/* Such string assignment is right? I remembered should use strcpy or need not using malloc */
	proname=(char *)malloc(15);
	p1=proname;
	strcpy(proname,fi->head_bfnd->entry.Template.bl_ptr1->ref->entry.Template.symbol->ident);
	/* while(*p1!='.') { 
	p1=p1+1;
	}*/
	/* strcpy(p1,p2);  */
	strcpy(sy->ident,proname);
	strcat(sy->ident,"_mc");
	temp_sy=fi->head_symb;
	while(temp_sy->thread!=NULL)
	{
		temp_sy=temp_sy->thread;
	}
	temp_sy->thread=sy;
	sy->thread=NULL;

	/*Creat TYPE */
	ty->variant=T_CLASS;
	ty->id=fi->num_types+1;
	fi->num_types=fi->num_types+1;
	temp_ty=fi->head_type;
	while(temp_ty->thread!=NULL)
	{
		temp_ty=temp_ty->thread;
	}
	temp_ty->thread=ty;
	ty->thread=NULL;

	/* add PROGRAM_NAME bfnd */
	bl->ref=fi->head_bfnd->entry.Template.bl_ptr1->ref;
	fi->head_bfnd->entry.Template.bl_ptr1->ref=bf;
}

addclassf(struct file_obj *fi)
{
	struct bfnd *bf,*temp_bf;
	struct blob *bl,*temp1_bl;
	struct symb *sy,*temp_sy;
	struct blob *stack[10];
	struct blob *stabp;
	struct data_type *ty,*temp_ty ;

	int i,k;
	char *funame,*addfuname;

	i=0;
	if(fi->head_bfnd->entry.Template.bl_ptr1->next!=NULL)
	{
		temp1_bl=fi->head_bfnd->entry.Template.bl_ptr1->next;
		while(temp1_bl!=NULL)
		{
			stack[i]=temp1_bl;
			i=i+1;
			temp1_bl=temp1_bl->next;
		}
		i=i-1;

		for(k=0;k<=i;k=k+1)
		{
			stabp=stack[k];
			bf=(struct bfnd *)malloc(sizeof(struct bfnd));
			bl=(struct blob *)malloc(sizeof(struct blob));
			sy=(struct symb *)malloc(sizeof(struct symb));
			ty=(struct data_type *)malloc(sizeof(struct data_type));

			initBfnd(bf);
			initBlob(bl);
			initSymb(sy);
			initType(ty);

			/* Creat BLOB */
			bl->next=NULL;
			bl->ref=NULL;
			fi->num_blobs=fi->num_blobs+1;

			/* Creat BFND */

			bf->variant=CLASS_DECL;
			bf->id=fi->num_bfnds+1;
			fi->num_bfnds=fi->num_bfnds+1;

			bf->entry.Template.symbol=sy;
			bf->entry.Template.bl_ptr1=bl;
        		bf->entry.Template.ll_ptr1=bf->entry.Template.ll_ptr2=bf->entry.Template.ll_ptr3=NULL;
			temp_bf=fi->head_bfnd;
			while(temp_bf->thread!=NULL)
			{
				temp_bf=temp_bf->thread;
			}
			temp_bf->thread=bf;
			bf->thread=NULL;

			/* Creat SYMB */
			sy->variant=CLASS_NAME;
			sy->id=fi->num_symbs+1;
			fi->num_symbs=fi->num_symbs+1;
			sy->type=ty;
			funame=stabp->ref->entry.Template.symbol->ident;
			sy->ident=(char *)malloc(15);
			addfuname=(char *)malloc(3);
			addfuname="_c";
			strcpy(sy->ident,funame);
			strcat(sy->ident,addfuname);
			temp_sy=fi->head_symb;
			while(temp_sy->thread!=NULL)
			{
				temp_sy=temp_sy->thread;
			}
			temp_sy->thread=sy;
			sy->thread=NULL;

			/*Creat TYPE */
			ty->variant=T_CLASS;
			ty->id=fi->num_types+1;
			fi->num_types=fi->num_types+1;
			temp_ty=fi->head_type;
			while(temp_ty->thread!=NULL)
			{
				temp_ty=temp_ty->thread;
			}
			temp_ty->thread=ty;
			ty->thread=NULL;

			/* add FUNC_NAME bfnd */
			bl->ref=stabp->ref;
			stabp->ref=bf;

		} /* forend  */

	} /* ifend */

	/* Here give information about FUNCTION node */
	else
	{
		/* printf("There are some subroutines\n");
    printf("I'm sorry for work about subroutines\n"); */
	}
}

/*trans_symb(PTR_SYMB sp)
* {
* PTR_SYMB sym;

* for(sym  = sp; sym; sym = sym->thread)
*   {
*    if(sym->variant == PROCEDURE_NAME || sym->variant == FUNCTION_NAME)
*     {
*       if(strcmp(sym->ident,"MAX") == 0)
*	  sym->entry.func_decl.tag = _MAX_;
*       else
*          if(strcmp(sym->ident,"MIN") == 0)
*             sym->entry.func_decl.tag = _MIN_;
*          else
*	     if(strcmp(sym->ident,"MOD") == 0)
*                sym->entry.func_decl.tag = _MOD_;
*             else
*                if(strcmp(sym->ident,"SEND") == 0)  
*                   sym->entry.func_decl.tag =_SEND_;
*                else      
*                   if(strcmp(sym->ident,"RECEIVE") == 0)
*                      sym->entry.func_decl.tag =_RECEIVE_;
*                   else
*                         sym->entry.func_decl.tag =_SELF_DEF_;
*     }		
*   }
}*/

trans_blck(struct bfnd *bp)
{
	PTR_BLOB blp1,blp2;

	if (bp != NULL)
	{
		blp1 = blp2 = NULL;
		/* blp1 = (struct blob *) malloc ( sizeof(struct blob) );
		 blp2 = (struct blob *) malloc ( sizeof(struct blob) ); */

		trans_bfnd( bp);

		if(bp->variant == PROC_HEDR)
		{
			scope = in_proc;

			for(blp1 = bp->entry.Template.bl_ptr1; blp1; blp1 = blp1->next)
				trans_blck(blp1->ref);

			for(blp2 = bp->entry.Template.bl_ptr2; blp2; blp2 = blp2->next)
				trans_blck(blp2->ref);
			scope = in_func;
		}
		else
		{
			for(blp1 = bp->entry.Template.bl_ptr1; blp1; blp1 = blp1->next)
				trans_blck(blp1->ref);

			for(blp2 = bp->entry.Template.bl_ptr2; blp2; blp2 = blp2->next)
				trans_blck(blp2->ref);
		}
	}

}

trans_bfnd( struct bfnd *bp)
{
	switch ( bp->variant ) {
	case    GLOBAL:
		break;
	case    PROG_HEDR:
		progtofunc( bp );
		break;
	case    PROC_HEDR:
	case    BLOCK_DATA:
		proctofunc( bp );
		del_var_decl_son_list(bp);
		break;
	case	FUNC_HEDR:
		del_var_decl_son_list(bp);
		break;
	case    ASSIGN_STAT:
		if( scope == in_func && isretnstat(bp) )
			assgntoretnd( bp );
		else
			assgntoexpr( bp);
		break;
	case    RETURN_STAT:
		retstatoretnd( bp );
		break;
	case    PROC_STAT:
		prcstatoexpr( bp );
		break;
	case	LOGIF_STMT:
	case	LOGIF_NODE:
		bp->variant = IF_NODE;
    case    DIM_STAT:
		bp->entry.Template.ll_ptr1->entry.Template.ll_ptr1->entry.Template.symbol->if_array=8888;
		break;
	case    ELSEIF_NODE:
	case    IF_NODE:
		iftoif( bp);
		break;
	case 	VAR_DECL:
		vartovar( bp );
		break;
	case    FOR_NODE:
		fortofor(bp );
		break;
		/*case : */
	default:
		;
	}
}

int isretnstat(struct bfnd *bp )
{
	if(bp->entry.assign.l_value->entry.var_ref.symbol->variant == FUNCTION_NAME)
		return(1);
	else
		return(0);
}

progtofunc( struct bfnd *bp )
{
	struct symb   *sp1 = (struct symb *) 0;
	struct llnd   *lp1, *lp2;
	struct data_type	*tp1;

	sp1 = (struct symb *) malloc ( sizeof (struct symb) );
	initSymb(sp1);
	lp1 = (struct llnd *) malloc ( sizeof (struct llnd) );
	initLlnd(lp1);
	lp2 = (struct llnd *) malloc ( sizeof (struct llnd) );
	initLlnd(lp2);
	tp1 = (struct data_type *) malloc ( sizeof (struct data_type) );
	initType(tp1);

	tp1->variant = DEFAULT;
	bp->variant = FUNC_HEDR;
	sp1->variant = FUNCTION_NAME;
	sp1->type = tp1;
	sp1->ident = "main";
	bp->entry.program.prog_symb = sp1;
	/* modify the symbol nodes */

	lp1->variant = EXPR_LIST;
	/*  lp1->type = DEFAULT; */
	bp->entry.program.null_1 = lp1;

	lp2->variant = FUNCTION_REF;
	lp2->entry.list.null_1 = sp1;
	lp1->entry.list.item = lp2;

	/* modify the low level nodes */
}

proctofunc( struct bfnd *bp )/* transfer a procedure_head or a block data head to  a function_head */
{
PTR_TYPE	tp;

	tp = (PTR_TYPE) malloc(sizeof(struct data_type));
	initType(tp);	
	tp->variant = T_VOID;

	bp->variant = FUNC_HEDR;
	bp->entry.Template.symbol->type = tp;
}

assgntoretnd( struct bfnd *bp )
{
	PTR_LLND lp1,lp2;

	lp1 = (struct llnd *) malloc ( sizeof (struct llnd) );
	initLlnd(lp1);
	lp2 = (struct llnd *) malloc ( sizeof (struct llnd) );
	initLlnd(lp2);

	bp->variant = RETURN_NODE;
	lp2->variant = EXPR_LIST;
	lp2->entry.Template.ll_ptr1 = bp->entry.assign.r_value;
	lp2->type = bp->entry.assign.l_value->type;

	lp1->variant = EXPR_LIST;
	lp1->entry.Template.ll_ptr1 = lp2;
	lp1->type = lp2->type;

	bp->entry.Template.ll_ptr1 = lp1;
}

prcstatoexpr(struct bfnd *bp)
{
	/* PTR_TYPE	tp[number];
 PTR_LLND       addr_op[number]; */
	PTR_LLND       expr,func,lp;
	int 		i;

	/*for (i = 0; i < number; i++)
     {
      addr_op[i] = (PTR_LLND)malloc( sizeof (struct llnd) );
	initLlnd(addr_op[i]);
      tp[i] = (PTR_TYPE)malloc( sizeof (struct data_type) );
	initType(tp[i]);
     } */
	expr = (PTR_LLND)malloc( sizeof (struct llnd) );
	initLlnd(expr);
	/* func = (PTR_LLND)malloc( sizeof (struct llnd) );
	initLlnd(func);

 func->variant = FUNC_CALL;
 func->entry.Template.ll_ptr1 = bp->entry.Template.ll_ptr1;
 func->entry.Template.symbol = bp->entry.Template.symbol;
  func->type = NULL;*/
	/* The above 6 lines were commented off because 
     the new AST has different structure from the Sigmas */

	expr->variant = EXPR_LIST;
	/* expr->entry.Template.ll_ptr1 = func; */
	/* The above line were commented off because 
     the new AST has different structure from the Sigmas */

	bp->entry.Template.ll_ptr1->variant = FUNC_CALL;
	expr->entry.Template.ll_ptr1 = bp->entry.Template.ll_ptr1;
	/*The above two lines were newly added to run on hpfFrontEnd */

	expr->type = func->type;

	bp->variant = EXPR_STMT_NODE;
	bp->entry.Template.ll_ptr1 = expr;
	/* func->entry.Template.ll_ptr1->type->variant = T_POINTER;
 for(i = 0,lp = func->entry.Template.ll_ptr1;lp;i++,lp = lp->entry.Template.ll_ptr2)
    {
     addr_op[i]->entry.Template.ll_ptr1 = lp->entry.Template.ll_ptr1;
     lp->entry.Template.ll_ptr1 = addr_op[i];
     addr_op[i]->type->variant = T_POINTER; 
    }*/
}

vartovar ( struct bfnd *bp )
{
	bp->entry.Template.ll_ptr1->type = bp->entry.Template.ll_ptr2->type;
	bp->entry.Template.ll_ptr2 = NULL;
}

assgntoexpr ( struct bfnd *bp)
{
	struct llnd   *lp1, *lp2;
	PTR_TYPE      type1;

	lp1 = (struct llnd *) malloc ( sizeof (struct llnd) );
	initLlnd(lp1);
	lp2 = (struct llnd *) malloc ( sizeof (struct llnd) );
	initLlnd(lp2);
	type1 = (PTR_TYPE) malloc ( sizeof (struct data_type) );
	initType(type1);
	lp2->variant = ASSGN_OP;
	lp2->type = bp->entry.assign.l_value->type;
	lp2->entry.Template.ll_ptr1 = bp->entry.assign.l_value;
	lp2->entry.Template.ll_ptr2 = bp->entry.assign.r_value;
	lp1->variant = EXPR_LIST;
	lp1->type = bp->entry.assign.l_value->type;
	lp1->entry.list.item = lp2;

	/* transLlnd(lp1); */

	bp->variant = EXPR_STMT_NODE;
	bp->entry.assign.l_value = lp1;
	bp->entry.assign.r_value = NULL;
}

/* Added to modify the AST of hpf front end
    in which MINUS_OP is used as the substitution of SUBT_OP */
void
transLlnd( struct llnd *lp)
{
	struct llnd   *tmplp;

	for(tmplp = lp; tmplp ; tmplp = tmplp->thread)
		if(tmplp->variant == MINUS_OP && 
		    tmplp->entry.Template.ll_ptr1 && 
		    tmplp->entry.Template.ll_ptr2)
			tmplp->variant = SUBT_OP;
}
/* Added to modify the AST of hpf front end 
    in which MINUS_OP is used as the substitution of SUBT_OP */
/* void
 transLlnd( struct llnd *lp)
 {

  struct llnd	*tmplp;

  for(tmplp = lp; tmplp ; tmplp = tmplp->entry.Template.ll_ptr2)
	switch(tmplp->variant) {
		case	EXPR_LIST :
			transLlnd(tmplp->entry.Template.ll_ptr1);
			break;
		case	MINUS_OP :
			if(tmplp->entry.Template.ll_ptr1 && tmplp->entry.Template.ll_ptr2) {
			    tmplp->variant = SUBT_OP; 
			    transLlnd(tmplp->entry.binary_op.l_operand);
			    transLlnd(tmplp->entry.binary_op.r_operand);
			}
			* if the left and the right sons are neither empty, then this is
			   a binary operater 
			break;
		case	ADD_OP :
		case	DIV_OP :
		case	MULT_OP :
		case	EXP_OP :
		case	EQV_OP:
		case	NEQV_OP:
		case	OR_OP:
		case	AND_OP:
		* case	NOT_OP: ********
		case	EQ_OP:
		case	NOTEQL_OP:
		case	LT_OP:
		case	LTEQL_OP:
		case	GT_OP:
		case	GTEQL_OP:
		/case	CONCAT_OP:********
			transLlnd(tmplp->entry.binary_op.l_operand);
			transLlnd(tmplp->entry.binary_op.r_operand);
			break;
		case	ASSGN_OP :
			transLlnd(tmplp->entry.Template.ll_ptr1);
			transLlnd(tmplp->entry.Template.ll_ptr2);
		default :
			break;
	}
  return;
 } */

iftoif( struct bfnd *bp)
{
	struct llnd   *lp1;
	PTR_BFND 	bp1,bp2;
	PTR_BLOB	tail,blp1,blp2;

	bp1 = ( PTR_BFND ) malloc ( sizeof (struct bfnd) );
	initBfnd(bp1);
	bp2 = ( PTR_BFND ) malloc ( sizeof (struct bfnd) );
	initBfnd(bp2);
	blp1 = ( PTR_BLOB ) malloc ( sizeof (struct blob) );
	initBlob(blp1);
	blp2 = ( PTR_BLOB ) malloc ( sizeof (struct blob) );
	initBlob(blp2);
	lp1 = ( PTR_LLND ) malloc ( sizeof (struct llnd) );
	initLlnd(lp1);

	if(bp->variant == ELSEIF_NODE)
		bp->variant = IF_NODE;

	if( bp->entry.if_node.control_false && bp->entry.if_node.control_false->ref->variant == ELSEIF_NODE)
	{
		tail = bp->entry.if_node.control_true;
		while(tail->next)
			tail = tail->next;

		bp1->variant = CONTROL_END;
		bp1->control_parent = bp;
		blp1->ref = bp1;
		blp1->next = tail->next;
		tail->next = blp1;

		tail = bp->entry.if_node.control_false;
		while(tail->next)
			tail = tail->next;

		bp2->variant = CONTROL_END;
		bp2->control_parent = bp;
		blp2->ref = bp2;
		blp2->next = tail->next;
		tail->next = blp2;
	}
	lp1->variant = EXPR_LIST;
	lp1->entry.list.item = bp->entry.if_node.condition;
	bp->entry.if_node.condition = lp1;
	/* Modify the condition expression */

}

retstatoretnd( PTR_BFND bp )
{
	bp->variant = RETURN_NODE;
}

/*Modified by Zheng Qiang to fit for Java */
fortofor( PTR_BFND bp )
{
	PTR_LLND lp[11];
	PTR_LLND incre;
	int i;
	PTR_LLND extra;

	if( bp->entry.for_node.range->entry.subscript.stride == NULL) {
		incre = (PTR_LLND) malloc (sizeof(struct llnd));
		initLlnd(incre);
		incre->variant = INT_VAL;
		incre->entry.ival = 1;
		bp->entry.for_node.range->entry.subscript.stride = incre;
	} /* to convert to the standard F-tree if the increment is null */

	for(i = 0;i < 11;i++) {
		lp[i] = (PTR_LLND) malloc (sizeof(struct llnd));
		initLlnd(lp[i]);
		(lp[i])->type = bp->entry.for_node.control_var->type;
	}

	for(i = 0;i <= 3; i++) {
		lp[i]->variant = VAR_REF;
		(lp[i])->entry.Template.symbol = bp->entry.for_node.control_var;
	}

	lp[4]->variant = ASSGN_OP;
	lp[4]->entry.Template.ll_ptr1 = lp[0];
	lp[4]->entry.Template.ll_ptr2 = bp->entry.for_node.range->entry.Template.ll_ptr1->entry.Template.ll_ptr1;  /* Modified to fit for Java */
	/* Convert the control_variable initialization */


	/* if(bp->entry.for_node.range->entry.binary_op.l_operand->entry.ival <= bp->entry.for_node.range->entry.binary_op.r_operand->entry.ival) */
	/* if(bp->entry.for_node.increment->entry.ival > 0 ) { 
	if(bp->entry.for_node.range->entry.subscript.stride->entry.ival > 0 ) {
	lp[5]->variant = LE_OP;
 	lp[6]->variant = ADD_OP;
      }
 else {
	lp[5]->variant = GE_OP; */
	/*    if(bp->entry.for_node.increment->variant == MINUS_OP) { */
	/*	if(bp->entry.for_node.range->entry.subscript.stride->entry.ival > 0 ) {
            lp[6]->variant = SUBT_OP;
	    extra = bp->entry.for_node.increment;
  	    bp->entry.for_node.increment = bp->entry.for_node.increment->entry.Template.ll_ptr1;
	    free(extra);
           }
      }*/
	if(bp->entry.for_node.range->entry.subscript.stride->variant == MINUS_OP) {
		lp[5]->variant = GE_OP;
		lp[6]->variant = SUBT_OP;
		bp->entry.for_node.increment = bp->entry.for_node.range->entry.subscript.stride->entry.unary_op_s.operand;
	}
	else {
		lp[5]->variant = LE_OP;
		lp[6]->variant = ADD_OP;
		bp->entry.for_node.increment = bp->entry.for_node.range->entry.subscript.stride;
	}
	lp[5]->entry.Template.ll_ptr1 = lp[1];
	lp[5]->entry.Template.ll_ptr2 = bp->entry.for_node.range->entry.subscript.range->entry.range.upper;
	lp[6]->entry.Template.ll_ptr1 = lp[2];
	lp[6]->entry.Template.ll_ptr2 = bp->entry.for_node.increment;

	lp[7]->variant = ASSGN_OP;
	lp[7]->entry.Template.ll_ptr1 = lp[3];
	lp[7]->entry.Template.ll_ptr2 = lp[6];

	for(i = 8;i < 11;i++)
		lp[i]->variant = EXPR_LIST;
	lp[8]->entry.Template.ll_ptr1 = lp[4];
	lp[9]->entry.Template.ll_ptr1 = lp[5];
	lp[10]->entry.Template.ll_ptr1 = lp[7];

	bp->entry.Template.ll_ptr1 = lp[8];
	bp->entry.Template.ll_ptr2 = lp[9];
	bp->entry.Template.ll_ptr3 = lp[10];
	bp->entry.Template.symbol = NULL;
}

void initBfnd(PTR_BFND bfPtr)
{
memset(bfPtr,0,sizeof(struct bfnd));
}

void initBlob(PTR_BLOB blPtr)
{
memset(blPtr,0,sizeof(struct blob));
}

void initSymb(PTR_SYMB symbPtr)
{
memset(symbPtr,0,sizeof(struct symb));
}

void initType(PTR_TYPE tPtr)
{
memset(tPtr,0,sizeof(struct data_type));
}

void initLlnd(PTR_LLND llPtr)
{
memset(llPtr,0,sizeof(struct llnd));
}
