# include <stdio.h>
# include <stddef.h>
# include <locale.h>
# include <stdlib.h>
# define U(x) ((x)&0377)
# define NCH 256
# define NLSTATE yyprevious=YYNEWLINE
# define BEGIN yybgin = yysvec + 1 +
# define INITIAL 0
# define YYLERR yysvec
# define YYSTATE (yyestate-yysvec-1)
# define YYOPTIM 1
# define YYLMAX 200

#ifdef __cplusplus
int yylook(void);
extern "C" int yywrap(void), yyless(int), yyreject(void);
#endif /* __cplusplus */

#if defined(__cplusplus) && defined(_CPP_IOSTREAMS)
# include <iostream.h>
# define output(c) (*yyout) << ((unsigned char) c)
# define input() (((yytchar=yysptr>yysbuf?U(*--yysptr):yyin->get())==10?(yylineno++,yytchar):yytchar)==EOF?0:yytchar)
# define ECHO (*yyout) << yytext
istream *yyin = &cin;
ostream *yyout = &cout;
#else
# define output(c) putc(c,yyout)
# define input() (((yytchar=yysptr>yysbuf?U(*--yysptr):getc(yyin))==10?(yylineno++,yytchar):yytchar)==EOF?0:yytchar)
# define ECHO fprintf(yyout, "%S",yywtext)
FILE *yyin = NULL, *yyout = NULL;
#endif /* defined(__cplusplus) && defined(_CPP_IOSTREAMS) */
# define unput(c) {yytchar= (c);if(yytchar=='\n')yylineno--;*yysptr++=yytchar;}
# define yymore() (yymorfg=1)
# define REJECT { yynstr = yyreject(); goto yyfussy;}
# define yysetlocale() setlocale(LC_ALL,"")
# define wreturn(r) return(yywreturn(r))
# define winput() yywinput()
# define wunput(c) yywunput(c)
# define woutput(c) yywoutput(c)
int yyleng;
extern char yytext[];
int yywleng; extern wchar_t yywtext[];
int yymorfg;
int yymbcurmax = -1;
int __once_yylex = 1;
extern unsigned char *yysptr, yysbuf[];
int yytchar;
extern int yylineno;
struct yywork;
struct yysvf { 
	struct yywork *yystoff;
	struct yysvf *yyother;
	int *yystops;};
struct yysvf *yyestate;
extern struct yysvf yysvec[], *yybgin;
# define aa 2
# define aaa 4
# define bb 6
# define cc 8
# define hh 10
# define ii 12
# define kk 14
# define ll 16
# define mm 18
# define zz 20
# define tt 22
# define jj 24
# define uu 26
# define hpf 28

/***
 aa indicates the inquire_stmt
 bb indicates the open_stmt
 cc indicates the read_stmt
 dd indicates all the stmts beginning with "end"
 ee indicates the case_stmt
 ff indicates the type_declaration_stmt
 gg indicates the use_stmt
 hh indicates the write_stmt
 ii indicates the close_stmt
 jj indicates the allocate_stmt
 kk indicates the backspace_stmt
 ll indicates the endfile_stmt
 mm indicates the rewind_stmt
 nn indicates the if_stmt
 oo indicates the assign_stmt
 pp indicates the interface_stmt
 qq indicates the intent_stmt
 rr indicates the function_stmt and entry_stmt: result
 ss indicates the print_stmt
 tt indictats the beginning with the label
 zz indicates the format_stmt
 uu indicates the implicit_stmt
***/

#ifdef HAVE_CONFIG_H
#include <config.h>                     /* config header file */
#endif

#include <stdlib.h>
#include <stdio.h>
#include <malloc.h>
#include "keywords.h"
#   include "typedef.h"
#   include "bif.h"
#   include "ll.h"
#   include "symb.h"

#include "defnodes.h"
#include "hpfparser.tab.h"

/*extern char yytext[YYLMAX];  yytext[0x400] (sun20) ; *yytext  (Linux) */ 

extern  int  debugFlag_g,intrFlag_g;
extern  int  fixedFormat_g;
extern  int  lineNum_g,lineNum_l;
extern  FILE *inf_ptr;
int namelist=0,common=0,acimp=0,acimp1=0,branu=0;
int cont;
char *copys();

char yytext[YYLMAX];
int yyback(int *yyp, int yym);
# if YYHSIZE
int yyhlook(int yyc, int yyv);
int yymlook(int yyc);
# endif /*YYHSIZE*/
# if YYXSIZE
int yyxlook (int yyc, int yyv);
#endif /*YYXSIZE*/
int yywinput();
void yywoutput(int yyc);
void yywunput(int yyc);
int yywreturn(int yyr);
int yyinput();
void yyoutput(int yyc);
void yyunput(int yyc);
#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */
int yymbinput();
void yymboutput(int yyc);
void yymbunput(int yyc);
int yymbreturn(int yyx);
#ifdef __cplusplus
}
#endif /* __cplusplus */
# define YYNEWLINE 10
#ifdef __cplusplus
extern "C"
#endif /*__cplusplus */
int yylex(){
int yynstr; extern int yyprevious;
   yyin=inf_ptr;
					/* zheng.gb 1996.5.29 */
#ifdef YYTEXT_IS_POINTER
  #ifdef IS_UNSIGNED_CHAR
   yytext = (unsigned char *) calloc(1,(unsigned)0x400);
  #else
   yytext = (char *) calloc(1,(unsigned)0x400);
  #endif
#endif
if (__once_yylex) {
      yysetlocale();
#if !(__cplusplus && _CPP_IOSTREAMS)
      if (yyin == NULL) yyin = stdin;
      if (yyout == NULL) yyout = stdout;
#endif /* !(__cplusplus && _CPP_IOSTREAMS) */
      __once_yylex = 0; }
if(yymbcurmax<=0) yymbcurmax=MB_CUR_MAX;
while((yynstr = yylook()) >= 0)
yyfussy: switch(yynstr){
case 0:
if(yywrap()) return(0); break;
case 1:
 {
   int i=0;
   if(fixedFormat_g==1)
     {
      if(debugFlag_g==1)
           printf("(fixed_C)\n");
      lineNum_g++;
      lineNum_l++;
      }
   else
     { 
       do 
        {  i++;
           }while(yytext[i]!=' ');
       yyless(i);
       yytext[i]='\0';
       yylval.charp = copys(yytext);
       return(NAME);
     }
}
/*NOTREACHED*/ break;
case 2:
 {
      lineNum_g++;
      lineNum_l++;
}
/*NOTREACHED*/ break;
case 3:
;
/*NOTREACHED*/ break;
case 4:
 {
   lineNum_g++;
   lineNum_l++;
}
/*NOTREACHED*/ break;
case 5:
 {
   char  temp[160];
   strcpy(temp,yytext);
   temp[6]='\0';
   if(strcmp(temp,"!HPF$ ")==0)
    { 
      yyless(5);
      if(debugFlag_g==1)
          printf("(!hpf)");
      BEGIN hpf;
      }
   else
     {
      lineNum_g++;
      lineNum_l++;
      }
}
/*NOTREACHED*/ break;
case 6:
 {
   if(debugFlag_g==1)
        printf("(commnet)");
   lineNum_g++;
   lineNum_l++;
   yylval.charp=copys(yytext);	
   return(COMMENT);
}
/*NOTREACHED*/ break;
case 7:
 {
   lineNum_g++; 
   lineNum_l++;
   cont=1; 
}
/*NOTREACHED*/ break;
case 8:
  {
   lineNum_g++; 
   lineNum_l++;
   cont=1; 
}
/*NOTREACHED*/ break;
case 9:
 ;
/*NOTREACHED*/ break;
case 10:
 {
    /* yytext[6]='\0'; */
   yylval.charp=copys(yytext);
   if(cont==1)
       return(DIGIT_STRING);
   if(debugFlag_g==1)
       printf("(label:%s)",yytext);
   BEGIN tt;	
   return(LABEL);
}
/*NOTREACHED*/ break;
case 11:
  {
   return(DIRDIMENSION);
}
/*NOTREACHED*/ break;
case 12:
 {
   return(DIRSEQUENCE);
}
/*NOTREACHED*/ break;
case 13:
{
   if(debugFlag_g==1)
      printf("(f_i),");
   return(I);
}
/*NOTREACHED*/ break;
case 14:
{
   if(debugFlag_g==1)
     printf("(f_b),");
   return(B);
}
/*NOTREACHED*/ break;
case 15:
{
   if(debugFlag_g==1)
       printf("(f_o),");
   return(O);
}
/*NOTREACHED*/ break;
case 16:
{
   if(debugFlag_g==1)
       printf("(f_z),");
   return(Z);
}
/*NOTREACHED*/ break;
case 17:
{
   if(debugFlag_g==1)
       printf("(f_f),");
   return(F);
}
/*NOTREACHED*/ break;
case 18:
{
   if(debugFlag_g==1)
       printf("(f_e),");
   return(E);
}
/*NOTREACHED*/ break;
case 19:
{
   if(debugFlag_g==1)
       printf("(f_en),");
   return(EN);
}
/*NOTREACHED*/ break;
case 20:
{
   if(debugFlag_g==1)
        printf("(f_es),");
   return(ES);
}
/*NOTREACHED*/ break;
case 21:
{
   if(debugFlag_g==1)
       printf("(f_g),");
   return(G);
}
/*NOTREACHED*/ break;
case 22:
{
   if(debugFlag_g==1)
       printf("(f_l),");
   return(L);
}
/*NOTREACHED*/ break;
case 23:
     case 24:
{
   if(debugFlag_g==1)
        printf("(f_a),");
   return(A);
}
/*NOTREACHED*/ break;
case 25:
{
   if(debugFlag_g==1)
        printf("(f_d),");
   return(D);
}
/*NOTREACHED*/ break;
case 26:
 {
   if(debugFlag_g==1)
       printf("(f_p),");
   return(P);
}
/*NOTREACHED*/ break;
case 27:
{
   if(debugFlag_g==1)
        printf("(f_t),");
   return(T);
}
/*NOTREACHED*/ break;
case 28:
{
   if(debugFlag_g==1)
       printf("(f_tl),");
   return(TL);
}
/*NOTREACHED*/ break;
case 29:
{
   if(debugFlag_g==1)
      printf("(f_tr),");
   return(TR);
}
/*NOTREACHED*/ break;
case 30:
 {
   if(debugFlag_g==1)
        printf("(f_x),");
   return(X);
}
/*NOTREACHED*/ break;
case 31:
 {
   if(debugFlag_g==1)
        printf("(f_s),");
   return(S);
}
/*NOTREACHED*/ break;
case 32:
 {
   if(debugFlag_g==1)
         printf("(f_sp),");
   return(SP);
}
/*NOTREACHED*/ break;
case 33:
 {
   if(debugFlag_g==1)
        printf("(f_ss),");
   return(SS);
}
/*NOTREACHED*/ break;
case 34:
 {
   if(debugFlag_g==1)
       printf("(f_bn),");
   return(BN);
}
/*NOTREACHED*/ break;
case 35:
 {
   if(debugFlag_g==1)
        printf("(f_bz),");
   return(BZ);
}
/*NOTREACHED*/ break;
case 36:
 {
   if(debugFlag_g==1)
        printf("(fh_ %s ),",yytext);
   yylval.charp=copys(yytext);
   return(H);
}
/*NOTREACHED*/ break;
case 37:
 {
   return(ACCESSL);
}
/*NOTREACHED*/ break;
case 38:
 {
   return(ACTION);
}
/*NOTREACHED*/ break;
case 39:
 {
   return(ADVANCE);
}
/*NOTREACHED*/ break;
case 40:
 {
   branu++;
   if(debugFlag_g==1)
         printf("(lb<cc,hh>),");
   return(LEFTBRACKET);
}
/*NOTREACHED*/ break;
case 41:
 {
   branu--;
   if(debugFlag_g==1)
        printf("(rb),");
   if(branu==0)
        BEGIN 0;
   return(RIGHTBRACKET);
}
/*NOTREACHED*/ break;
case 42:
 {
   if(debugFlag_g==1)
       printf("(com2),");
   return(COMMA2);
}
/*NOTREACHED*/ break;
case 43:
 {
   return(BLANK);
}
/*NOTREACHED*/ break;
case 44:
 {
   return(DELIM);
}
/*NOTREACHED*/ break;
case 45:
 {
   return(DIRECT);
}
/*NOTREACHED*/ break;
case 46:
 {
   return(ENDR);
}
/*NOTREACHED*/ break;
case 47:
 {
   return(ERR);
}
/*NOTREACHED*/ break;
case 48:
 {
   return(EXIST);
}
/*NOTREACHED*/ break;
case 49:
 {
   return(STATUS);
}
/*NOTREACHED*/ break;
case 50:
 {
   return(READWRITE);
}
/*NOTREACHED*/ break;
case 51:
 {
   BEGIN 0;
   BEGIN aaa;
   return(IOLENGTH);
}
/*NOTREACHED*/ break;
case 52:
 {
   return(IOSTAT);
}
/*NOTREACHED*/ break;
case 53:
 {
   return(WRITEI);
}
/*NOTREACHED*/ break;
case 54:
{
   return(UNFORMATTED);
}
/*NOTREACHED*/ break;
case 55:
{
   return(UNIT);
}
/*NOTREACHED*/ break;
case 56:
{
   return(SEQUENTIAL);
}
/*NOTREACHED*/ break;
case 57:
 {
   return(SIZE);
}
/*NOTREACHED*/ break;
case 58:
 {
   return(REC);
}
/*NOTREACHED*/ break;
case 59:
 {
   return(RECL);
}
/*NOTREACHED*/ break;
case 60:
 {
   return(READI);
}
/*NOTREACHED*/ break;
case 61:
 {
   return(POSITION);
}
/*NOTREACHED*/ break;
case 62:
 {
   return(PAD);
}
/*NOTREACHED*/ break;
case 63:
 {
   return(OPENED);
}
/*NOTREACHED*/ break;
case 64:
 {
   return(NUMBER);
}
/*NOTREACHED*/ break;
case 65:
 {
   return(NEXTREC);
}
/*NOTREACHED*/ break;
case 66:
 {
   return(NML);
}
/*NOTREACHED*/ break;
case 67:
 {
   return(NAMEI);
}
/*NOTREACHED*/ break;
case 68:
 {
   return(NAMED);
}
/*NOTREACHED*/ break;
case 69:
 {
   return(EOR);
}
/*NOTREACHED*/ break;
case 70:
 {
   return(FILEI);
}
/*NOTREACHED*/ break;
case 71:
 {
   return(FMT);
}
/*NOTREACHED*/ break;
case 72:
 {
   return(FORM);
}
/*NOTREACHED*/ break;
case 73:
 {
   return(FORMATTED);
}
/*NOTREACHED*/ break;
case 74:
 {
   return(STAT);
}
/*NOTREACHED*/ break;
case 75:
 {
   if(cont==1)
       return(FUNNAME); 
   else
      return(REAL);
}
/*NOTREACHED*/ break;
case 76:
 {
   if(debugFlag_g==1)
       printf("(real<uu>)");
   return(REAL);
}
/*NOTREACHED*/ break;
case 77:
{
   if(debugFlag_g==1)
        printf("(lb2<uu>)");
   yyless(1);
   return(LEFTBRACKET2);
}
/*NOTREACHED*/ break;
case 78:
 {
   if(debugFlag_g==1)
        printf("(implicit_letter %s)",yytext);
   return(IMPLICITLETTER);
}
/*NOTREACHED*/ break;
case 79:
 {
   if(debugFlag_g==1)
       printf("(kind=)");
   return(KINDEQ);
}
/*NOTREACHED*/ break;
case 80:
     {
   if(debugFlag_g==1)
        printf("(len=)");
   return(LENEQ);
}
/*NOTREACHED*/ break;
case 81:
 {
   return(DOUBLEPRE);
}
/*NOTREACHED*/ break;
case 82:
 {
   return(BLOCKDATA);
}
/*NOTREACHED*/ break;
case 83:
 {
   return(INOUT);
}
/*NOTREACHED*/ break;
case 84:
 {
   return(GOTO);
}
/*NOTREACHED*/ break;
case 85:
 {
   return(SELECTCASE);
}
/*NOTREACHED*/ break;
case 86:
{
   return(ELSEWHERE);
}
/*NOTREACHED*/ break;
case 87:
 {
   yyless(yyleng-1);
   return(ELSEIF);
}
/*NOTREACHED*/ break;
case 88:
 {
   return(ENDDO);
}
/*NOTREACHED*/ break;
case 89:
 {
   return(ENDIF);
}
/*NOTREACHED*/ break;
case 90:
 {
   return(ENDSELECT);
}
/*NOTREACHED*/ break;
case 91:
 {
   return(ENDWHERE);
}
/*NOTREACHED*/ break;
case 92:
 {
   return(ENDFORALL);
}
/*NOTREACHED*/ break;
case 93:
 {
   return(ENDTYPE);
}
/*NOTREACHED*/ break;
case 94:
 {
   return(ENDINTERFACE);
}
/*NOTREACHED*/ break;
case 95:
 {
   return(ENDMODULE);
}
/*NOTREACHED*/ break;
case 96:
 {
   return(ENDBLOCKDATA);
}
/*NOTREACHED*/ break;
case 97:
 {
   return(ENDSUBROUTINE);
}
/*NOTREACHED*/ break;
case 98:
 {
   return(ENDFUNCTION);
}
/*NOTREACHED*/ break;
case 99:
{
   return(ENDPROGRAM);
}
/*NOTREACHED*/ break;
case 100:
 {
   return(FALSEL);
}
/*NOTREACHED*/ break;
case 101:
  { 
   return(TRUEL);
}
/*NOTREACHED*/ break;
case 102:
 {
   return(EQV);
}
/*NOTREACHED*/ break;
case 103:
 {
   return(NEQV);
}
/*NOTREACHED*/ break;
case 104:
 {
   return(OR);
}
/*NOTREACHED*/ break;
case 105:
 {
   return(AND);
}
/*NOTREACHED*/ break;
case 106:
 {
   return(NOT);
}
/*NOTREACHED*/ break;
case 107:
 {
   return(EQ);
}
/*NOTREACHED*/ break;
case 108:
 {
   return(EQ);
}
/*NOTREACHED*/ break;
case 109:
 {
   return(NE);
}
/*NOTREACHED*/ break;
case 110:
 {
   return(NE);
}
/*NOTREACHED*/ break;
case 111:
 {
   return(LT);
}
/*NOTREACHED*/ break;
case 112:
 {
   return(LT);
}
/*NOTREACHED*/ break;
case 113:
 {
   return(LE);
}
/*NOTREACHED*/ break;
case 114:
 {
   return(LE);
}
/*NOTREACHED*/ break;
case 115:
 {
   return(GT);
}
/*NOTREACHED*/ break;
case 116:
 {
   return(GT);
}
/*NOTREACHED*/ break;
case 117:
 {
   return(GE);
}
/*NOTREACHED*/ break;
case 118:
 {
   return(GE);
}
/*NOTREACHED*/ break;
case 119:
 {
   if(debugFlag_g==1)
        printf("(=>)");
   return(EQGT);
}
/*NOTREACHED*/ break;
case 120:
 {
   return(COLON);
}
/*NOTREACHED*/ break;
case 121:
 {
   if(debugFlag_g==1)
         printf("(;)"); 
   BEGIN 0;
   BEGIN aa;
   BEGIN bb;
   return(CARRIAGE2);
}
/*NOTREACHED*/ break;
case 122:
 {
   return(QUESTION);
}
/*NOTREACHED*/ break;
case 123:
 {
   if(debugFlag_g==1)
        printf("(=)");
   return(EQUAL);
}
/*NOTREACHED*/ break;
case 124:
  {
   return(DOUBLECOLON);
}
/*NOTREACHED*/ break;
case 125:
   {
   return(UNDERSCORE);
}
/*NOTREACHED*/ break;
case 126:
  {
   yyless(yyleng-1);
   if(debugFlag_g==1)
       printf("(_1),");
   return(UNDERSCORE1);
}
/*NOTREACHED*/ break;
case 127:
 {
   yyless(yyleng-1);
   if(debugFlag_g==1)
         printf("(_1),");
   return(UNDERSCORE1);
}
/*NOTREACHED*/ break;
case 128:
 {
  if(common==1 || namelist==1)
   {
     yyless(yyleng-1);
     return(COMMA1);
     }
   else
   {
     yyless(yyleng-1);
     return(COMMA);
     }
}
/*NOTREACHED*/ break;
case 129:
 {
   common=0;
   namelist=0;
   cont=0;
   if(debugFlag_g==1)
       printf("(car)\n");
   BEGIN 0;
   return(CARRIAGE1);
}
/*NOTREACHED*/ break;
case 130:
 {
   if(debugFlag_g==1)
         printf("(%),");
   return(PERCENT);
}
/*NOTREACHED*/ break;
case 131:
 {
   if(debugFlag_g==1)
         printf("(,),");
   return(COMMA);
}
/*NOTREACHED*/ break;
case 132:
 {
   if(debugFlag_g==1)
        printf("(.),");
   return(FULLPOINT);
}
/*NOTREACHED*/ break;
case 133:
 {
   if(debugFlag_g==1)
         printf("(dqstr),");
   yylval.charp=copys(yytext);
   return(STRING);
}
/*NOTREACHED*/ break;
case 134:
 {
   if(debugFlag_g==1)
         printf("(sqstr),");
   yylval.charp=copys(yytext);
   return(STRING);
}
/*NOTREACHED*/ break;
case 135:
 {
   int i,j;
   char chara,cha_arr[80];

   if(acimp==1)
    { 
      i=1;j=0;
      while(i!=0)
        { 
          chara=input();
          if(chara=='(')
 		i++;
          if(chara==')')
		i--;
          cha_arr[j++]=chara;
          if(chara=='=')
             {
         	acimp1=1;
		break;
  		}
	  }
       j--;		
       for(j;j>=0;j--)
           unput(cha_arr[j]);	
       if(acimp1==1)		
        { 
          acimp1=0;		
          if(debugFlag_g==1)
              printf("(lb1),");
          return(LEFTBRACKET1);
          }
    	else
          { 
            if(debugFlag_g==1)
               printf("(lb),");
            return(LEFTBRACKET);
            }
        }
   else 
   { 
         if(debugFlag_g==1)
           printf("(lb),");
         return(LEFTBRACKET);
    }
}
/*NOTREACHED*/ break;
case 136:
   {
   yyless(1);
   return(LEFTBRACKET);
}
/*NOTREACHED*/ break;
case 137:
 {
   acimp=1; 
   return(ACVALUE1);
}
/*NOTREACHED*/ break;
case 138:
 {
   if(debugFlag_g==1)
          printf("(rb),");
   return(RIGHTBRACKET);
}
/*NOTREACHED*/ break;
case 139:
 {
   if(debugFlag_g==1)
        printf("(+),");
   return(PLUS);
}
/*NOTREACHED*/ break;
case 140:
 {
   if(debugFlag_g==1)
        printf("(-),");
   return(MINUS);
}
/*NOTREACHED*/ break;
case 141:
 {
   if(debugFlag_g==1)
        printf("(*),");
   return(MULTIPLY);
}
/*NOTREACHED*/ break;
case 142:
 {
   if(debugFlag_g==1)
        printf("(/),");
   return(DIVIDE);
}
/*NOTREACHED*/ break;
case 143:
 {
   acimp=0;
   return(ACVALUE2);
}
/*NOTREACHED*/ break;
case 144:
 {
   if(debugFlag_g==1)
       printf("(**),");
   return(POWER);
}
/*NOTREACHED*/ break;
case 145:
 {
   if(common==1)
     { yyless(yyleng-1);
       return(DIVIDE);
       }
   else
      return(CONCAT);
}
/*NOTREACHED*/ break;
case 146:
 {
   yylval.charp=copys(yytext);
   return(REAL_LITERAL_CONST);
}
/*NOTREACHED*/ break;
case 147:
{
   yylval.charp=copys(yytext);
   return(DOUBLE_LITERAL_CONST);
}
/*NOTREACHED*/ break;
case 148:
{
   return(keynameDeal_m(yytext));
}
/*NOTREACHED*/ break;
case 149:
{
   return(BINARY_CONST);
}
/*NOTREACHED*/ break;
case 150:
{
   return(OCTAL_CONST);
}
/*NOTREACHED*/ break;
case 151:
{
   return(HEX_CONST);
}
/*NOTREACHED*/ break;
case 152:
 {
   yylval.charp=copys(yytext);
   if(debugFlag_g==1)
        printf("(Digit %s)\n",yytext);
   return(DIGIT_STRING);
}
/*NOTREACHED*/ break;
case 153:
 {
   yylval.charp=copys(yytext);
   return(DEFINED_OPERATOR);
}
/*NOTREACHED*/ break;
case -1:
break;
default:
#if defined(__cplusplus) && defined(_CPP_IOSTREAMS)
(*yyout) << "bad switch yylook " << yynstr;
#else
fprintf(yyout,"bad switch yylook %d",yynstr);
#endif /* defined(__cplusplus) && defined(_CPP_IOSTREAMS)*/
} return(0); }
/* end of yylex */
yywrap()
{
  return(1);
}


/*******  "nameCmp_m" : if equl then return 0; nequl return 1  ********/

/*    int nameCmp_m(char buf1[35],char buf2[35])   */
int nameCmp_m(buf1,buf2)
char buf1[35];
char buf2[35];
{
   int i=0;
   int len1,len2;

   len1=strlen(buf1);
   len2=strlen(buf2);
   if(len1!=len2)return 1;

   do
    {
      if (buf1[i]!=buf2[i]&&buf1[i]-32!=buf2[i]&&buf1[i]!=buf2[i]-32)
           return 1;
        else i++;
     }while(i!=len1);
   return 0;
   }


/*********  "searchKey_m" : if find the keyword or funcname return it's
            index , else return limit         ***********/

/*   int searchKey_m(char name[35],char tab[120][35],int limit)  */
int searchKey_m(name,tab,limit)
char name[35];
char tab[120][35];
{
   int i=0;
   int flag=0;

   do
    {
        if(nameCmp_m(name,tab[i])==0)
            flag=1;
        else
             i++;
    }while (!((flag==1)||(i==limit))) ;
    return(i);
}

/*   int keynameDeal_m(char name[35])   */
int keynameDeal_m(name)
char name[35];
{
   int i;
   int returnValue_m;
   char chara;

   yylval.charp=copys( name ); 
   if((i=searchKey_m(name,FUNC_TAB_G,FUNC_TAB_LIMIT_G))<FUNC_TAB_LIMIT_G)
        {
/* return (NAME);                                 zheng.gb 1996.5.30 */
	 if (intrFlag_g ==1) return (NAME);
	 do {
             chara=input();
             }while(chara==' ');
         if(chara=='(')                 /*** "funname( )" : FUNNAME  ***/
               { unput(chara);
       	 	 if(debugFlag_g==1)
       	      		printf("(func_name: %s  %d)\n",name,i);
                 return(FUNNAME);
               }
          else 
               { unput(chara);
                 return(NAME);
               }
        }
   else
        { 
         if((i=searchKey_m(name,KEY_WORD_G,KEY_WORD_LIMIT_G))<KEY_WORD_LIMIT_G)
             { 
	       if(debugFlag_g==1)
                     printf("(keyword: %s  %d)\n",name,i);
               switch(i){
	        case 0:  BEGIN zz;    /* format */
                         break;
		case 1:
                case 2:  BEGIN jj;    /* (de)allocate */
                         break;
                case 3:  common=1;    /* common */
                         break;
                case 4:  namelist=1;  /* namelist */
                         break;
                case 5:  	    /*character */
                         break;
                case 6:  BEGIN bb;    /*  open  */
                         break;
                case 7:               /*  read  */
			 do {
			     chara=input();
			 }while(chara==' ');
                         if(chara=='(')
			      BEGIN cc;
                         unput(chara);
                         break;
                case 8:  BEGIN hh;    /*  write */
                         break;
                case 9:  BEGIN mm;    /* rewind */
                         break;
                case 10: BEGIN kk;    /*backspace*/
                         break;
                case 11: BEGIN ll;    /*endfile */
                         break;
		case 12: BEGIN ii;    /* close  */
			 break;
		case 13: BEGIN aa;    /* inquire */
			 break;
		case 14:              /* integer */
		case 15:              /* logical */
		case 16:              /* complex */
			 break;
                case 17: BEGIN uu;    /* implicit */
                         break;
                default: ;
                }
		/* returnValue_m=257+i; */
		returnValue_m=FORMAT+i;    /* modified by zheng.gb */
                return(returnValue_m);   
              }
         else
             {
               if(debugFlag_g==1) 
                   printf("(It's a name: %s)\n",name);
               return(NAME);
               }
        }
}
int yyvstop[] = {
0,

3,
0,

129,
0,

130,
0,

135,
0,

138,
0,

141,
0,

139,
0,

131,
0,

140,
0,

132,
0,

142,
0,

152,
0,

120,
0,

121,
0,

112,
0,

123,
0,

116,
0,

122,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

125,
0,

3,
0,

4,
129,
0,

9,
0,

141,
0,

152,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

40,
135,
0,

41,
138,
0,

42,
131,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

23,
148,
-24,
0,

148,
-14,
0,

148,
-25,
0,

148,
-18,
0,

148,
-17,
0,

148,
-21,
0,

36,
148,
0,

148,
-13,
0,

148,
-22,
0,

148,
-15,
0,

26,
148,
0,

31,
148,
0,

148,
-27,
0,

30,
148,
0,

148,
-16,
0,

148,
0,

135,
0,

78,
148,
0,

78,
148,
0,

78,
148,
0,

78,
148,
0,

78,
148,
0,

78,
148,
0,

78,
148,
0,

78,
148,
0,

78,
148,
0,

78,
148,
0,

78,
148,
0,

78,
148,
0,

78,
148,
0,

78,
148,
0,

148,
0,

148,
0,

6,
0,

133,
0,

7,
0,

134,
0,

137,
0,

144,
0,

128,
0,

146,
147,
0,

143,
0,

145,
0,

110,
0,

146,
147,
0,

124,
0,

114,
0,

108,
0,

119,
0,

118,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

127,
0,

126,
0,

4,
0,

9,
0,

5,
6,
0,

2,
0,

10,
0,

152,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

24,
148,
0,

14,
148,
0,

34,
148,
0,

35,
148,
0,

25,
148,
0,

18,
148,
0,

148,
-19,
0,

148,
-20,
0,

17,
148,
0,

21,
148,
0,

36,
0,

13,
148,
0,

22,
148,
0,

15,
148,
0,

32,
148,
0,

33,
148,
0,

27,
148,
0,

148,
-28,
0,

148,
-29,
0,

16,
148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

8,
0,

136,
0,

153,
0,

147,
0,

146,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

5,
0,

1,
0,

10,
0,

152,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

19,
148,
0,

20,
148,
0,

28,
148,
0,

29,
148,
0,

148,
0,

77,
0,

148,
0,

148,
0,

148,
0,

148,
0,

147,
0,

146,
0,

107,
153,
0,

117,
153,
0,

115,
153,
0,

113,
153,
0,

111,
153,
0,

109,
153,
0,

104,
153,
0,

149,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

84,
148,
0,

148,
0,

148,
0,

80,
0,

150,
0,

148,
0,

151,
0,

10,
0,

152,
0,

75,
148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

47,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

62,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

46,
0,

69,
0,

71,
0,

66,
0,

58,
0,

148,
0,

148,
0,

76,
148,
0,

75,
76,
148,
0,

148,
0,

148,
0,

105,
153,
0,

102,
153,
0,

106,
153,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

88,
148,
0,

148,
0,

148,
0,

89,
148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

84,
0,

83,
148,
0,

79,
0,

148,
0,

75,
0,

10,
0,

152,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

70,
0,

72,
0,

148,
0,

148,
0,

148,
0,

67,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

60,
0,

148,
0,

59,
0,

148,
0,

148,
0,

55,
0,

148,
0,

148,
0,

148,
0,

57,
0,

74,
0,

148,
0,

148,
0,

103,
153,
0,

101,
153,
0,

148,
0,

148,
0,

148,
0,

148,
0,

88,
0,

89,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

83,
0,

148,
0,

10,
0,

148,
0,

148,
0,

43,
0,

44,
0,

148,
0,

48,
0,

148,
0,

148,
0,

148,
0,

68,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

53,
0,

148,
0,

148,
0,

148,
0,

148,
0,

100,
153,
0,

148,
0,

148,
0,

87,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

93,
148,
0,

148,
0,

148,
0,

37,
0,

38,
0,

45,
0,

148,
0,

148,
0,

52,
0,

148,
0,

64,
0,

63,
0,

148,
0,

148,
0,

148,
0,

148,
0,

49,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

93,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

148,
0,

91,
148,
0,

148,
0,

148,
0,

148,
0,

65,
0,

148,
0,

148,
0,

148,
0,

148,
0,

39,
0,

148,
0,

12,
148,
0,

82,
148,
0,

148,
0,

86,
148,
0,

91,
0,

148,
0,

92,
148,
0,

148,
0,

148,
0,

95,
148,
0,

148,
0,

90,
148,
0,

148,
0,

148,
0,

148,
0,

51,
0,

61,
0,

148,
0,

148,
0,

148,
0,

148,
-11,
0,

82,
0,

148,
0,

86,
0,

92,
0,

95,
0,

90,
0,

148,
0,

148,
0,

148,
0,

99,
148,
0,

148,
0,

85,
148,
0,

73,
0,

50,
0,

148,
0,

148,
0,

11,
0,

148,
0,

99,
0,

148,
0,

98,
148,
0,

148,
0,

148,
0,

85,
0,

56,
0,

148,
0,

148,
0,

98,
0,

96,
148,
0,

94,
148,
0,

148,
0,

54,
0,

148,
0,

96,
0,

94,
0,

97,
148,
0,

148,
0,

97,
0,

81,
148,
0,

81,
0,
0};
# define YYTYPE unsigned short
struct yywork { YYTYPE verify, advance; } yycrank[] = {
	0,0,	0,0,	0,0,	0,0,
	0,0,	0,0,	0,0,	0,0,
	0,0,	0,0,	1,31,	1,32,
	0,0,	0,0,	0,0,	0,0,
	0,0,	0,0,	0,0,	0,0,
	0,0,	0,0,	0,0,	0,0,
	0,0,	0,0,	0,0,	0,0,
	0,0,	0,0,	0,0,	0,0,
	0,0,	1,31,	1,33,	1,34,
	0,0,	0,0,	1,35,	1,36,
	1,37,	1,38,	1,39,	1,40,
	1,41,	1,42,	1,43,	1,44,
	1,45,	1,46,	1,46,	1,46,
	1,46,	1,46,	1,46,	1,46,
	1,46,	1,46,	1,46,	1,47,
	1,48,	1,49,	1,50,	1,51,
	1,52,	38,143,	1,53,	1,54,
	1,53,	1,55,	1,56,	1,53,
	1,57,	1,53,	1,58,	1,53,
	1,59,	1,60,	1,53,	1,53,
	1,61,	1,53,	1,53,	1,53,
	1,62,	1,53,	1,53,	1,53,
	1,53,	1,53,	1,53,	1,63,
	40,144,	47,163,	25,120,	49,164,
	1,64,	51,167,	1,53,	1,54,
	1,53,	1,55,	1,56,	1,53,
	1,57,	1,53,	1,58,	1,53,
	1,59,	1,60,	1,53,	1,53,
	1,61,	1,53,	1,53,	1,53,
	1,62,	1,53,	1,53,	1,53,
	1,53,	1,53,	1,53,	1,63,
	2,65,	2,66,	25,120,	42,145,
	29,136,	45,157,	55,171,	36,36,
	36,140,	50,165,	50,166,	45,158,
	71,192,	71,193,	143,259,	61,178,
	63,181,	54,168,	42,146,	29,137,
	61,179,	63,182,	54,169,	2,65,
	2,67,	45,159,	278,362,	64,183,
	57,174,	2,68,	36,36,	36,141,
	64,184,	2,69,	279,362,	71,192,
	29,136,	290,383,	55,171,	2,70,
	2,70,	2,70,	2,70,	2,70,
	2,70,	2,70,	2,70,	2,70,
	2,70,	3,73,	3,74,	29,137,
	3,75,	3,76,	3,77,	134,192,
	134,193,	3,78,	2,71,	54,170,
	57,174,	13,88,	3,79,	3,80,
	3,81,	13,90,	3,82,	3,83,
	56,172,	3,84,	56,173,	3,85,
	58,175,	2,72,	59,176,	13,92,
	15,88,	13,93,	134,192,	291,383,
	15,90,	3,73,	3,74,	60,177,
	3,75,	3,76,	3,77,	4,65,
	4,66,	3,78,	62,180,	54,170,
	15,93,	13,88,	3,79,	3,80,
	3,81,	13,90,	3,82,	3,83,
	56,172,	3,84,	56,173,	3,85,
	58,175,	2,72,	59,176,	13,92,
	15,88,	13,93,	4,65,	4,67,
	15,90,	293,385,	130,178,	60,177,
	4,68,	72,196,	73,197,	130,179,
	4,69,	294,385,	62,180,	705,731,
	15,93,	0,0,	4,70,	4,70,
	4,70,	4,70,	4,70,	4,70,
	4,70,	4,70,	4,70,	4,70,
	17,88,	19,88,	82,212,	0,0,
	17,90,	19,90,	83,213,	4,73,
	4,74,	4,71,	4,75,	4,76,
	4,77,	72,196,	73,197,	4,78,
	17,93,	19,93,	69,192,	69,193,
	4,79,	4,80,	4,81,	523,585,
	4,86,	4,83,	84,214,	4,84,
	85,215,	4,85,	74,168,	523,585,
	17,88,	19,88,	82,212,	74,169,
	17,90,	19,90,	83,213,	4,73,
	4,74,	69,192,	4,75,	4,76,
	4,77,	6,65,	6,66,	4,78,
	17,93,	19,93,	80,178,	69,144,
	4,79,	4,80,	4,81,	80,179,
	4,86,	4,83,	84,214,	4,84,
	85,215,	4,85,	7,73,	7,74,
	0,0,	7,87,	7,88,	7,89,
	6,65,	6,67,	7,90,	0,0,
	74,198,	0,0,	6,68,	77,203,
	86,216,	7,81,	6,69,	7,91,
	7,92,	77,204,	7,93,	91,219,
	6,70,	6,70,	6,70,	6,70,
	6,70,	6,70,	6,70,	6,70,
	6,70,	6,70,	7,73,	7,74,
	80,209,	7,87,	7,88,	7,89,
	8,65,	8,66,	7,90,	6,71,
	74,198,	78,175,	78,205,	77,203,
	86,216,	7,81,	0,0,	7,91,
	7,92,	77,204,	7,93,	91,219,
	133,181,	0,0,	6,72,	90,175,
	90,218,	133,182,	81,210,	8,65,
	8,67,	168,278,	168,278,	0,0,
	80,209,	8,68,	0,0,	93,221,
	0,0,	8,69,	0,0,	94,222,
	81,211,	78,175,	78,205,	8,70,
	8,70,	8,70,	8,70,	8,70,
	8,70,	8,70,	8,70,	8,70,
	8,70,	79,206,	6,72,	90,175,
	90,218,	79,207,	81,210,	87,199,
	8,73,	8,74,	8,71,	8,87,
	8,88,	8,89,	75,199,	93,221,
	8,90,	87,171,	75,200,	94,222,
	81,211,	79,208,	289,381,	8,81,
	75,171,	8,94,	8,92,	0,0,
	8,93,	98,223,	89,203,	169,279,
	169,279,	79,206,	9,95,	9,96,
	89,217,	79,207,	9,97,	87,199,
	8,73,	8,74,	100,226,	8,87,
	8,88,	8,89,	75,199,	0,0,
	8,90,	87,171,	75,200,	289,382,
	476,550,	79,208,	92,180,	8,81,
	75,171,	8,94,	8,92,	9,98,
	8,93,	98,223,	89,203,	9,99,
	9,100,	101,227,	102,228,	9,90,
	89,217,	92,220,	104,230,	549,550,
	9,101,	120,180,	100,226,	476,550,
	9,102,	9,103,	124,171,	9,93,
	0,0,	103,180,	583,585,	10,65,
	10,66,	103,229,	92,180,	126,174,
	120,251,	116,180,	583,585,	9,98,
	0,0,	0,0,	549,550,	9,99,
	9,100,	101,227,	102,228,	9,90,
	116,245,	92,220,	104,230,	116,246,
	9,101,	120,180,	10,65,	10,67,
	9,102,	9,103,	124,171,	9,93,
	10,68,	103,180,	10,95,	10,96,
	10,69,	103,229,	10,97,	126,174,
	120,251,	116,180,	10,70,	10,70,
	10,70,	10,70,	10,70,	10,70,
	10,70,	10,70,	10,70,	10,70,
	116,245,	0,0,	0,0,	116,246,
	11,95,	11,96,	0,0,	10,98,
	11,97,	10,71,	0,0,	10,99,
	10,100,	123,168,	0,0,	10,90,
	127,175,	0,0,	123,169,	128,176,
	10,101,	307,396,	0,0,	0,0,
	10,104,	10,103,	76,172,	10,93,
	76,173,	11,98,	129,177,	131,254,
	76,201,	11,88,	11,100,	132,180,
	135,255,	11,90,	76,202,	10,98,
	137,257,	0,0,	11,101,	10,99,
	10,100,	0,0,	11,102,	10,90,
	127,175,	11,93,	307,397,	128,176,
	10,101,	12,65,	12,66,	123,170,
	10,104,	10,103,	76,172,	10,93,
	76,173,	11,98,	129,177,	131,254,
	76,201,	11,88,	11,100,	132,180,
	135,255,	11,90,	76,202,	125,172,
	137,257,	125,173,	11,101,	149,149,
	12,65,	12,67,	11,102,	0,0,
	170,280,	11,93,	12,68,	136,256,
	12,95,	12,96,	12,69,	123,170,
	12,97,	136,171,	0,0,	0,0,
	12,70,	12,70,	12,70,	12,70,
	12,70,	12,70,	12,70,	12,70,
	12,70,	12,70,	88,172,	125,172,
	88,173,	125,173,	151,265,	149,149,
	88,201,	12,98,	171,281,	12,71,
	170,280,	12,88,	12,100,	136,256,
	0,0,	12,90,	154,270,	151,149,
	150,149,	136,171,	12,101,	150,264,
	14,65,	14,66,	12,104,	154,149,
	154,271,	12,93,	172,282,	0,0,
	0,0,	0,0,	88,172,	0,0,
	88,173,	174,284,	151,265,	0,0,
	88,201,	12,98,	171,281,	173,283,
	176,288,	12,88,	12,100,	14,65,
	14,67,	12,90,	154,270,	151,149,
	150,149,	14,68,	12,101,	150,264,
	317,407,	14,69,	12,104,	154,149,
	154,271,	12,93,	172,282,	14,70,
	14,70,	14,70,	14,70,	14,70,
	14,70,	14,70,	14,70,	14,70,
	14,70,	0,0,	330,421,	173,283,
	176,288,	0,0,	0,0,	0,0,
	0,0,	0,0,	14,71,	155,149,
	14,88,	317,408,	0,0,	155,272,
	14,90,	174,285,	177,289,	0,0,
	0,0,	0,0,	16,65,	16,66,
	180,292,	14,72,	14,92,	190,297,
	14,93,	175,286,	46,160,	330,422,
	46,46,	46,46,	46,46,	46,46,
	46,46,	46,46,	46,46,	46,46,
	46,46,	46,46,	0,0,	155,149,
	14,88,	16,65,	16,67,	155,272,
	14,90,	174,285,	177,289,	16,68,
	46,161,	46,162,	331,423,	16,69,
	180,292,	14,72,	14,92,	190,297,
	14,93,	16,70,	16,70,	16,70,
	16,70,	16,70,	16,70,	16,70,
	16,70,	16,70,	16,70,	99,172,
	152,266,	99,224,	99,225,	196,301,
	175,287,	99,201,	0,0,	153,268,
	16,71,	152,149,	16,88,	331,424,
	46,161,	46,162,	16,90,	152,267,
	153,149,	0,0,	199,305,	200,306,
	18,65,	18,66,	153,269,	16,72,
	198,304,	0,0,	16,93,	0,0,
	0,0,	0,0,	0,0,	99,172,
	152,266,	99,224,	99,225,	196,301,
	175,287,	99,201,	198,280,	153,268,
	197,302,	152,149,	16,88,	18,65,
	18,67,	201,307,	16,90,	152,267,
	153,149,	18,68,	199,305,	200,306,
	332,425,	18,69,	153,269,	16,72,
	198,304,	197,303,	16,93,	18,70,
	18,70,	18,70,	18,70,	18,70,
	18,70,	18,70,	18,70,	18,70,
	18,70,	0,0,	198,280,	0,0,
	197,302,	0,0,	0,0,	156,149,
	202,308,	201,307,	18,71,	156,273,
	18,88,	332,426,	0,0,	203,309,
	18,90,	204,310,	206,313,	0,0,
	205,311,	197,303,	20,65,	20,66,
	207,314,	18,72,	208,315,	205,312,
	18,93,	105,231,	105,231,	105,231,
	105,231,	105,231,	105,231,	105,231,
	105,231,	105,231,	105,231,	156,149,
	202,308,	0,0,	0,0,	156,273,
	18,88,	20,65,	20,67,	203,309,
	18,90,	204,310,	206,313,	20,68,
	205,311,	209,316,	333,427,	20,69,
	207,314,	18,72,	208,315,	205,312,
	18,93,	20,70,	20,70,	20,70,
	20,70,	20,70,	20,70,	20,70,
	20,70,	20,70,	20,70,	178,290,
	178,290,	178,290,	178,290,	178,290,
	178,290,	178,290,	178,290,	210,317,
	20,71,	211,318,	20,88,	333,428,
	0,0,	209,316,	20,90,	179,291,
	179,291,	179,291,	179,291,	179,291,
	179,291,	179,291,	179,291,	20,72,
	215,324,	217,326,	20,93,	0,0,
	0,0,	21,105,	21,106,	218,312,
	21,107,	21,108,	21,109,	21,110,
	21,111,	21,112,	219,320,	210,317,
	21,113,	211,318,	20,88,	21,114,
	21,115,	220,327,	20,90,	21,116,
	21,117,	0,0,	0,0,	0,0,
	21,118,	221,323,	21,119,	20,72,
	215,324,	217,326,	20,93,	22,65,
	22,66,	21,105,	21,106,	218,312,
	21,107,	21,108,	21,109,	21,110,
	21,111,	21,112,	219,320,	0,0,
	21,113,	0,0,	0,0,	21,114,
	21,115,	220,327,	214,322,	21,116,
	21,117,	214,323,	22,65,	22,67,
	21,118,	221,323,	21,119,	0,0,
	22,68,	0,0,	0,0,	0,0,
	22,69,	212,319,	0,0,	212,320,
	223,328,	0,0,	22,70,	22,70,
	22,70,	22,70,	22,70,	22,70,
	22,70,	22,70,	22,70,	22,70,
	0,0,	213,292,	214,322,	224,329,
	0,0,	214,323,	213,321,	22,105,
	22,106,	22,71,	22,107,	22,108,
	22,109,	22,110,	22,111,	22,112,
	225,330,	212,319,	22,113,	212,320,
	223,328,	22,114,	22,115,	226,331,
	22,72,	22,116,	22,117,	0,0,
	0,0,	216,325,	22,118,	216,320,
	22,119,	213,292,	0,0,	224,329,
	24,65,	24,66,	213,321,	22,105,
	22,106,	0,0,	22,107,	22,108,
	22,109,	22,110,	22,111,	22,112,
	225,330,	0,0,	22,113,	0,0,
	0,0,	22,114,	22,115,	226,331,
	22,72,	22,116,	22,117,	24,65,
	24,67,	216,325,	22,118,	216,320,
	22,119,	24,68,	222,301,	227,332,
	222,320,	24,69,	228,333,	229,334,
	26,65,	26,66,	251,339,	24,70,
	24,70,	24,70,	24,70,	24,70,
	24,70,	24,70,	24,70,	24,70,
	24,70,	0,0,	0,0,	0,0,
	0,0,	230,301,	0,0,	230,333,
	254,341,	255,342,	24,71,	26,65,
	26,67,	256,343,	222,301,	227,332,
	222,320,	26,68,	228,333,	229,334,
	0,0,	26,69,	251,339,	0,0,
	0,0,	24,72,	0,0,	26,70,
	26,70,	26,70,	26,70,	26,70,
	26,70,	26,70,	26,70,	26,70,
	26,70,	230,301,	27,121,	230,333,
	254,341,	255,342,	0,0,	0,0,
	0,0,	256,343,	26,71,	109,239,
	109,239,	109,239,	109,239,	109,239,
	109,239,	109,239,	109,239,	109,239,
	109,239,	24,72,	265,352,	280,363,
	265,149,	26,72,	26,120,	27,122,
	27,123,	27,122,	27,124,	27,125,
	27,122,	27,126,	27,122,	27,127,
	27,122,	27,128,	27,129,	27,122,
	27,122,	27,130,	27,122,	27,122,
	27,131,	27,132,	27,122,	27,122,
	27,122,	27,122,	27,122,	27,122,
	27,133,	0,0,	265,352,	280,363,
	265,149,	26,72,	26,120,	27,122,
	27,123,	27,122,	27,124,	27,125,
	27,122,	27,126,	27,122,	27,127,
	27,122,	27,128,	27,129,	27,122,
	27,122,	27,130,	27,122,	27,122,
	27,131,	27,132,	27,122,	27,122,
	27,122,	27,122,	27,122,	27,122,
	27,133,	28,65,	28,66,	160,160,
	160,160,	160,160,	160,160,	160,160,
	160,160,	160,160,	160,160,	160,160,
	160,160,	231,231,	231,231,	231,231,
	231,231,	231,231,	231,231,	231,231,
	231,231,	231,231,	231,231,	266,353,
	28,65,	28,67,	253,253,	0,0,
	0,0,	0,0,	28,68,	0,0,
	28,121,	0,0,	28,69,	253,340,
	0,0,	0,0,	253,340,	253,340,
	28,70,	28,70,	28,70,	28,70,
	28,70,	28,70,	28,70,	28,70,
	28,70,	28,70,	0,0,	257,292,
	281,364,	267,354,	282,365,	266,149,
	257,344,	28,122,	28,123,	28,134,
	28,124,	28,125,	28,122,	28,126,
	28,122,	28,127,	28,122,	28,128,
	28,129,	28,122,	28,122,	28,130,
	28,122,	28,122,	28,135,	28,132,
	28,122,	28,122,	28,122,	28,122,
	28,122,	28,122,	28,133,	257,292,
	281,364,	267,149,	282,365,	266,149,
	257,344,	28,122,	28,123,	28,122,
	28,124,	28,125,	28,122,	28,126,
	28,122,	28,127,	28,122,	28,128,
	28,129,	28,122,	28,122,	28,130,
	28,122,	28,122,	28,135,	28,132,
	28,122,	28,122,	28,122,	28,122,
	28,122,	28,122,	28,133,	30,65,
	30,66,	267,149,	107,235,	107,235,
	107,235,	107,235,	107,235,	107,235,
	107,235,	107,235,	107,235,	107,235,
	232,232,	232,232,	232,232,	232,232,
	232,232,	232,232,	232,232,	232,232,
	232,232,	232,232,	30,65,	30,67,
	263,349,	380,470,	0,0,	285,377,
	30,68,	0,0,	0,0,	287,379,
	30,69,	107,171,	263,149,	268,355,
	288,380,	0,0,	30,70,	30,70,
	30,70,	30,70,	30,70,	30,70,
	30,70,	30,70,	30,70,	30,70,
	0,0,	0,0,	0,0,	0,0,
	0,0,	33,33,	380,471,	292,384,
	263,349,	30,71,	30,136,	285,377,
	381,381,	33,33,	33,138,	287,379,
	297,387,	107,171,	263,149,	268,149,
	288,380,	161,274,	0,0,	161,274,
	30,72,	30,137,	161,275,	161,275,
	161,275,	161,275,	161,275,	161,275,
	161,275,	161,275,	161,275,	161,275,
	33,33,	0,0,	33,33,	292,384,
	0,0,	381,382,	30,136,	33,33,
	33,33,	33,33,	33,33,	33,33,
	297,387,	0,0,	0,0,	268,149,
	33,33,	0,0,	33,33,	0,0,
	30,72,	30,137,	0,0,	0,0,
	33,33,	0,0,	0,0,	0,0,
	0,0,	33,33,	269,356,	264,350,
	396,396,	33,33,	33,33,	33,33,
	33,33,	33,33,	33,33,	33,33,
	33,33,	33,33,	33,33,	33,33,
	33,33,	33,33,	33,33,	33,33,
	33,33,	33,33,	33,33,	33,33,
	33,33,	33,33,	33,33,	33,33,
	33,33,	33,33,	33,33,	114,178,
	34,34,	396,397,	269,149,	264,149,
	114,179,	273,149,	0,0,	33,33,
	34,34,	34,34,	0,0,	264,351,
	273,361,	114,244,	114,244,	114,244,
	114,244,	114,244,	114,244,	114,244,
	114,244,	114,244,	114,244,	399,483,
	271,149,	301,390,	302,391,	303,392,
	0,0,	0,0,	271,359,	34,34,
	0,0,	34,139,	269,149,	264,149,
	0,0,	273,149,	34,34,	34,34,
	34,34,	34,34,	34,34,	264,351,
	273,361,	0,0,	0,0,	34,34,
	0,0,	34,34,	284,284,	0,0,
	399,484,	0,0,	0,0,	34,34,
	271,149,	301,390,	302,391,	303,392,
	34,34,	270,357,	271,359,	407,407,
	34,34,	34,34,	34,34,	34,34,
	34,34,	34,34,	34,34,	34,34,
	34,34,	34,34,	34,34,	34,34,
	34,34,	34,34,	34,34,	34,34,
	34,34,	34,34,	34,34,	34,34,
	34,34,	34,34,	34,34,	34,34,
	34,34,	34,34,	119,181,	37,37,
	407,408,	270,149,	304,393,	119,182,
	270,358,	0,0,	34,34,	37,37,
	37,37,	0,0,	284,376,	286,286,
	119,250,	119,250,	119,250,	119,250,
	119,250,	119,250,	119,250,	119,250,
	119,250,	119,250,	411,500,	305,394,
	306,395,	272,360,	0,0,	0,0,
	308,398,	309,399,	37,37,	0,0,
	37,37,	270,149,	304,393,	0,0,
	270,358,	37,142,	37,37,	37,37,
	37,37,	37,37,	284,376,	0,0,
	0,0,	0,0,	37,37,	0,0,
	37,37,	0,0,	0,0,	411,501,
	0,0,	0,0,	37,37,	305,394,
	306,395,	272,149,	286,378,	37,37,
	308,398,	309,399,	310,400,	37,37,
	37,37,	37,37,	37,37,	37,37,
	37,37,	37,37,	37,37,	37,37,
	37,37,	37,37,	37,37,	37,37,
	37,37,	37,37,	37,37,	37,37,
	37,37,	37,37,	37,37,	37,37,
	37,37,	37,37,	37,37,	37,37,
	37,37,	272,149,	286,378,	0,0,
	0,0,	0,0,	310,400,	0,0,
	0,0,	37,37,	44,147,	44,147,
	44,147,	44,147,	44,147,	44,147,
	44,147,	44,147,	44,147,	44,147,
	0,0,	311,401,	312,402,	313,403,
	314,404,	315,405,	316,406,	44,148,
	44,149,	44,149,	44,149,	44,150,
	44,151,	44,152,	44,149,	44,149,
	44,149,	44,149,	44,153,	44,149,
	44,154,	44,155,	44,149,	44,149,
	44,149,	44,149,	44,156,	44,149,
	44,149,	44,149,	44,149,	44,149,
	44,149,	311,401,	312,402,	313,403,
	314,404,	315,405,	316,406,	44,148,
	44,149,	44,149,	44,149,	44,150,
	44,151,	44,152,	44,149,	44,149,
	44,149,	44,149,	44,153,	44,149,
	44,154,	44,155,	44,149,	44,149,
	44,149,	44,149,	44,156,	44,149,
	44,149,	44,149,	44,149,	44,149,
	44,149,	53,53,	0,0,	113,243,
	113,243,	113,243,	113,243,	113,243,
	113,243,	113,243,	113,243,	113,243,
	113,243,	53,53,	53,53,	53,53,
	53,53,	53,53,	53,53,	53,53,
	53,53,	53,53,	53,53,	0,0,
	113,177,	318,409,	319,410,	320,411,
	0,0,	321,412,	53,53,	53,53,
	53,53,	53,53,	53,53,	53,53,
	53,53,	53,53,	53,53,	53,53,
	53,53,	53,53,	53,53,	53,53,
	53,53,	53,53,	53,53,	53,53,
	53,53,	53,53,	53,53,	53,53,
	53,53,	53,53,	53,53,	53,53,
	113,177,	318,409,	319,410,	320,411,
	53,53,	321,412,	53,53,	53,53,
	53,53,	53,53,	53,53,	53,53,
	53,53,	53,53,	53,53,	53,53,
	53,53,	53,53,	53,53,	53,53,
	53,53,	53,53,	53,53,	53,53,
	53,53,	53,53,	53,53,	53,53,
	53,53,	53,53,	53,53,	53,53,
	65,185,	65,186,	108,236,	108,236,
	108,236,	108,236,	108,236,	108,236,
	108,236,	108,236,	108,236,	108,236,
	0,0,	147,147,	147,147,	147,147,
	147,147,	147,147,	147,147,	147,147,
	147,147,	147,147,	147,147,	65,185,
	65,187,	0,0,	414,504,	322,413,
	323,414,	65,188,	108,172,	324,415,
	108,237,	147,260,	147,261,	326,416,
	327,417,	108,238,	328,418,	65,189,
	65,189,	65,189,	65,189,	65,189,
	65,189,	65,189,	65,189,	65,189,
	65,189,	67,67,	0,0,	334,429,
	339,430,	325,410,	341,431,	414,505,
	0,0,	67,67,	67,191,	322,413,
	323,414,	325,390,	108,172,	324,415,
	108,237,	147,260,	147,261,	326,416,
	327,417,	108,238,	328,418,	342,432,
	416,485,	65,190,	343,433,	344,434,
	349,435,	0,0,	351,436,	359,439,
	67,67,	0,0,	67,67,	334,429,
	339,430,	325,410,	341,431,	67,67,
	67,67,	67,67,	67,67,	67,67,
	0,0,	325,390,	0,0,	0,0,
	67,67,	0,0,	67,67,	0,0,
	0,0,	416,486,	0,0,	342,432,
	67,67,	65,190,	343,433,	344,434,
	349,149,	67,67,	351,149,	359,149,
	363,441,	67,67,	67,67,	67,67,
	67,67,	67,67,	67,67,	67,67,
	67,67,	67,67,	67,67,	67,67,
	67,67,	67,67,	67,67,	67,67,
	67,67,	67,67,	67,67,	67,67,
	67,67,	67,67,	67,67,	67,67,
	67,67,	67,67,	67,67,	70,194,
	349,149,	364,442,	351,149,	359,149,
	363,441,	367,455,	419,419,	67,67,
	0,0,	106,168,	0,0,	0,0,
	0,0,	0,0,	106,169,	0,0,
	368,456,	371,461,	372,462,	0,0,
	373,463,	0,0,	70,194,	106,232,
	106,232,	106,232,	106,232,	106,232,
	106,232,	106,232,	106,232,	106,232,
	106,232,	364,442,	374,465,	419,420,
	373,464,	367,455,	70,195,	70,195,
	70,195,	70,195,	70,195,	70,195,
	70,195,	70,195,	70,195,	70,195,
	368,456,	371,461,	372,462,	106,170,
	373,463,	106,233,	0,0,	110,240,
	110,240,	110,240,	110,240,	110,240,
	110,240,	110,240,	110,240,	110,240,
	110,240,	106,234,	374,465,	111,241,
	373,464,	375,466,	421,421,	358,149,
	361,440,	0,0,	0,0,	111,241,
	111,241,	0,0,	0,0,	358,438,
	376,467,	361,149,	162,276,	106,170,
	162,276,	106,233,	110,174,	162,277,
	162,277,	162,277,	162,277,	162,277,
	162,277,	162,277,	162,277,	162,277,
	162,277,	106,234,	111,241,	421,422,
	111,241,	375,466,	111,111,	358,149,
	361,440,	111,241,	111,241,	111,0,
	111,241,	111,241,	111,0,	358,438,
	376,467,	361,149,	111,111,	0,0,
	111,111,	0,0,	110,174,	0,0,
	0,0,	0,0,	111,111,	0,0,
	0,0,	352,149,	378,468,	111,241,
	379,469,	0,0,	352,437,	111,111,
	111,111,	111,111,	111,111,	111,111,
	111,111,	111,111,	111,111,	111,111,
	111,111,	111,111,	111,111,	111,111,
	111,111,	111,111,	111,111,	111,111,
	111,111,	111,111,	111,111,	111,111,
	111,111,	111,111,	111,111,	111,111,
	111,111,	352,149,	378,468,	0,0,
	379,469,	111,111,	352,437,	0,0,
	0,0,	111,111,	112,242,	112,242,
	112,242,	112,242,	112,242,	112,242,
	112,242,	112,242,	112,242,	112,242,
	117,247,	117,247,	117,247,	117,247,
	117,247,	117,247,	117,247,	117,247,
	117,247,	117,247,	235,235,	235,235,
	235,235,	235,235,	235,235,	235,235,
	235,235,	235,235,	235,235,	235,235,
	112,175,	369,457,	370,459,	384,472,
	387,474,	391,477,	392,478,	369,458,
	117,248,	393,479,	370,460,	394,480,
	395,481,	398,482,	117,249,	121,252,
	236,236,	236,236,	236,236,	236,236,
	236,236,	236,236,	236,236,	236,236,
	236,236,	236,236,	0,0,	0,0,
	0,0,	0,0,	121,143,	0,0,
	112,175,	369,457,	370,459,	384,472,
	387,474,	391,477,	392,478,	369,458,
	117,248,	393,479,	370,460,	394,480,
	395,481,	398,482,	117,249,	401,488,
	121,253,	121,253,	121,253,	121,253,
	121,253,	121,253,	121,253,	121,253,
	121,253,	121,253,	121,253,	121,253,
	121,253,	121,253,	121,253,	121,253,
	121,253,	121,253,	121,253,	121,253,
	121,253,	121,253,	121,253,	121,253,
	121,253,	121,253,	0,0,	0,0,
	402,489,	404,493,	400,485,	401,488,
	121,253,	121,253,	121,253,	121,253,
	121,253,	121,253,	121,253,	121,253,
	121,253,	121,253,	121,253,	121,253,
	121,253,	121,253,	121,253,	121,253,
	121,253,	121,253,	121,253,	121,253,
	121,253,	121,253,	121,253,	121,253,
	121,253,	121,253,	141,141,	400,486,
	402,489,	404,493,	405,494,	400,487,
	423,423,	0,0,	141,141,	141,258,
	237,335,	237,335,	237,335,	237,335,
	237,335,	237,335,	237,335,	237,335,
	237,335,	237,335,	238,336,	238,336,
	238,336,	238,336,	238,336,	238,336,
	238,336,	238,336,	238,336,	238,336,
	237,283,	141,141,	0,0,	141,141,
	0,0,	423,424,	405,494,	400,487,
	141,141,	141,141,	141,141,	141,141,
	141,141,	0,0,	0,0,	0,0,
	0,0,	141,141,	0,0,	141,141,
	0,0,	0,0,	0,0,	0,0,
	0,0,	141,141,	0,0,	0,0,
	0,0,	406,495,	141,141,	409,496,
	237,283,	412,502,	141,141,	141,141,
	141,141,	141,141,	141,141,	141,141,
	141,141,	141,141,	141,141,	141,141,
	141,141,	141,141,	141,141,	141,141,
	141,141,	141,141,	141,141,	141,141,
	141,141,	141,141,	141,141,	141,141,
	141,141,	141,141,	141,141,	141,141,
	148,262,	406,495,	0,0,	409,496,
	0,0,	412,502,	0,0,	0,0,
	141,141,	239,239,	239,239,	239,239,
	239,239,	239,239,	239,239,	239,239,
	239,239,	239,239,	239,239,	148,149,
	148,149,	148,149,	148,149,	148,149,
	148,149,	148,149,	148,149,	148,149,
	148,149,	148,149,	148,149,	148,149,
	148,263,	148,149,	148,149,	148,149,
	148,149,	148,149,	148,149,	148,149,
	148,149,	148,149,	148,149,	148,149,
	148,149,	0,0,	0,0,	0,0,
	0,0,	0,0,	0,0,	148,149,
	148,149,	148,149,	148,149,	148,149,
	148,149,	148,149,	148,149,	148,149,
	148,149,	148,149,	148,149,	148,149,
	148,263,	148,149,	148,149,	148,149,
	148,149,	148,149,	148,149,	148,149,
	148,149,	148,149,	148,149,	148,149,
	148,149,	181,293,	181,293,	181,293,
	181,293,	181,293,	181,293,	181,293,
	181,293,	181,293,	181,293,	425,425,
	0,0,	0,0,	0,0,	413,503,
	0,0,	415,506,	181,293,	181,293,
	181,293,	181,293,	181,293,	181,293,
	182,294,	182,294,	182,294,	182,294,
	182,294,	182,294,	182,294,	182,294,
	182,294,	182,294,	0,0,	0,0,
	417,507,	418,508,	0,0,	0,0,
	425,426,	182,294,	182,294,	182,294,
	182,294,	182,294,	182,294,	413,503,
	187,187,	415,506,	181,293,	181,293,
	181,293,	181,293,	181,293,	181,293,
	187,187,	187,295,	240,240,	240,240,
	240,240,	240,240,	240,240,	240,240,
	240,240,	240,240,	240,240,	240,240,
	417,507,	418,508,	427,427,	403,490,
	429,509,	182,294,	182,294,	182,294,
	182,294,	182,294,	182,294,	187,187,
	430,511,	187,187,	0,0,	0,0,
	0,0,	0,0,	187,187,	187,187,
	187,187,	187,187,	187,187,	0,0,
	0,0,	0,0,	0,0,	187,187,
	0,0,	187,187,	0,0,	427,428,
	403,491,	429,510,	0,0,	187,187,
	0,0,	0,0,	0,0,	403,492,
	187,187,	430,512,	433,513,	434,514,
	187,187,	187,187,	187,187,	187,187,
	187,187,	187,187,	187,187,	187,187,
	187,187,	187,187,	187,187,	187,187,
	187,187,	187,187,	187,187,	187,187,
	187,187,	187,187,	187,187,	187,187,
	187,187,	187,187,	187,187,	187,187,
	187,187,	187,187,	189,194,	403,492,
	0,0,	0,0,	433,513,	434,514,
	438,516,	0,0,	187,187,	0,0,
	0,0,	0,0,	0,0,	0,0,
	0,0,	0,0,	0,0,	0,0,
	192,192,	0,0,	442,520,	470,470,
	444,523,	189,194,	410,497,	0,0,
	192,192,	192,298,	242,242,	242,242,
	242,242,	242,242,	242,242,	242,242,
	242,242,	242,242,	242,242,	242,242,
	438,149,	189,296,	189,296,	189,296,
	189,296,	189,296,	189,296,	189,296,
	189,296,	189,296,	189,296,	192,192,
	470,471,	192,192,	442,520,	410,498,
	444,523,	0,0,	192,192,	192,192,
	192,192,	192,192,	192,192,	0,0,
	0,0,	0,0,	0,0,	192,192,
	0,0,	192,192,	0,0,	0,0,
	438,149,	0,0,	0,0,	192,192,
	0,0,	0,0,	0,0,	445,524,
	192,192,	410,499,	446,525,	447,526,
	192,192,	192,192,	192,192,	192,192,
	192,192,	192,192,	192,192,	192,192,
	192,192,	192,192,	192,192,	192,192,
	192,192,	192,192,	192,192,	192,192,
	192,192,	192,192,	192,192,	192,192,
	192,192,	192,192,	192,192,	192,192,
	192,192,	192,192,	195,299,	445,524,
	0,0,	410,499,	446,525,	447,526,
	440,517,	0,0,	192,192,	0,0,
	0,0,	0,0,	0,0,	0,0,
	0,0,	0,0,	0,0,	0,0,
	241,241,	0,0,	450,531,	451,532,
	453,535,	195,299,	0,0,	0,0,
	241,241,	241,241,	243,243,	243,243,
	243,243,	243,243,	243,243,	243,243,
	243,243,	243,243,	243,243,	243,243,
	440,149,	195,300,	195,300,	195,300,
	195,300,	195,300,	195,300,	195,300,
	195,300,	195,300,	195,300,	241,241,
	0,0,	241,241,	450,531,	451,532,
	453,535,	0,0,	241,241,	241,241,
	241,0,	241,241,	241,241,	241,0,
	0,0,	0,0,	0,0,	241,241,
	0,0,	241,241,	0,0,	0,0,
	440,149,	0,0,	0,0,	241,241,
	0,0,	0,0,	454,536,	455,537,
	241,241,	457,538,	458,539,	460,540,
	241,241,	241,241,	241,241,	241,241,
	241,241,	241,241,	241,241,	241,241,
	241,241,	241,241,	241,241,	241,241,
	241,241,	241,241,	241,241,	241,241,
	241,241,	241,241,	241,241,	241,241,
	241,241,	241,241,	241,241,	241,241,
	241,241,	241,241,	454,536,	455,537,
	0,0,	457,538,	458,539,	460,540,
	0,0,	0,0,	241,241,	244,244,
	244,244,	244,244,	244,244,	244,244,
	244,244,	244,244,	244,244,	244,244,
	244,244,	247,247,	247,247,	247,247,
	247,247,	247,247,	247,247,	247,247,
	247,247,	247,247,	247,247,	248,337,
	248,337,	248,337,	248,337,	248,337,
	248,337,	248,337,	248,337,	248,337,
	248,337,	249,338,	249,338,	249,338,
	249,338,	249,338,	249,338,	249,338,
	249,338,	249,338,	249,338,	250,250,
	250,250,	250,250,	250,250,	250,250,
	250,250,	250,250,	250,250,	250,250,
	250,250,	252,252,	260,345,	0,0,
	260,345,	0,0,	0,0,	260,346,
	260,346,	260,346,	260,346,	260,346,
	260,346,	260,346,	260,346,	260,346,
	260,346,	261,347,	0,0,	261,347,
	0,0,	0,0,	261,348,	261,348,
	261,348,	261,348,	261,348,	261,348,
	261,348,	261,348,	261,348,	261,348,
	461,541,	462,542,	252,253,	252,253,
	252,253,	252,253,	252,253,	252,253,
	252,253,	252,253,	252,253,	252,253,
	252,253,	252,253,	252,253,	252,253,
	252,253,	252,253,	252,253,	252,253,
	252,253,	252,253,	252,253,	252,253,
	252,253,	252,253,	252,253,	252,253,
	0,0,	0,0,	0,0,	0,0,
	461,541,	462,542,	252,253,	252,253,
	252,253,	252,253,	252,253,	252,253,
	252,253,	252,253,	252,253,	252,253,
	252,253,	252,253,	252,253,	252,253,
	252,253,	252,253,	252,253,	252,253,
	252,253,	252,253,	252,253,	252,253,
	252,253,	252,253,	252,253,	252,253,
	274,275,	274,275,	274,275,	274,275,
	274,275,	274,275,	274,275,	274,275,
	274,275,	274,275,	276,277,	276,277,
	276,277,	276,277,	276,277,	276,277,
	276,277,	276,277,	276,277,	276,277,
	283,366,	335,335,	335,335,	335,335,
	335,335,	335,335,	335,335,	335,335,
	335,335,	335,335,	335,335,	441,518,
	365,443,	0,0,	0,0,	0,0,
	0,0,	296,299,	336,336,	336,336,
	336,336,	336,336,	336,336,	336,336,
	336,336,	336,336,	336,336,	336,336,
	0,0,	0,0,	0,0,	0,0,
	0,0,	0,0,	283,367,	0,0,
	283,368,	0,0,	283,369,	463,543,
	296,299,	283,370,	464,544,	465,545,
	448,527,	283,371,	449,529,	441,519,
	283,372,	300,388,	448,528,	283,373,
	283,374,	365,444,	449,530,	283,375,
	296,386,	296,386,	296,386,	296,386,
	296,386,	296,386,	296,386,	296,386,
	296,386,	296,386,	283,367,	365,445,
	283,368,	329,419,	283,369,	463,543,
	300,388,	283,370,	464,544,	465,545,
	448,527,	283,371,	449,529,	441,519,
	283,372,	0,0,	448,528,	283,373,
	283,374,	365,444,	449,530,	283,375,
	300,389,	300,389,	300,389,	300,389,
	300,389,	300,389,	300,389,	300,389,
	300,389,	300,389,	329,420,	365,445,
	0,0,	0,0,	0,0,	329,367,
	437,515,	329,368,	466,546,	329,369,
	468,547,	472,548,	329,370,	477,551,
	478,552,	437,149,	329,371,	0,0,
	0,0,	329,372,	479,553,	480,555,
	329,373,	329,374,	482,558,	481,557,
	329,375,	337,337,	337,337,	337,337,
	337,337,	337,337,	337,337,	337,337,
	337,337,	337,337,	337,337,	329,367,
	437,515,	329,368,	466,546,	329,369,
	468,547,	472,548,	329,370,	477,551,
	478,552,	437,149,	329,371,	479,554,
	480,556,	329,372,	0,0,	482,559,
	329,373,	329,374,	366,366,	481,557,
	329,375,	338,338,	338,338,	338,338,
	338,338,	338,338,	338,338,	338,338,
	338,338,	338,338,	338,338,	345,346,
	345,346,	345,346,	345,346,	345,346,
	345,346,	345,346,	345,346,	345,346,
	345,346,	347,348,	347,348,	347,348,
	347,348,	347,348,	347,348,	347,348,
	347,348,	347,348,	347,348,	483,483,
	366,446,	485,485,	366,447,	452,533,
	366,448,	487,560,	0,0,	366,449,
	488,561,	489,562,	0,0,	366,450,
	493,565,	490,490,	366,451,	386,388,
	492,563,	366,452,	366,453,	452,534,
	0,0,	366,454,	0,0,	0,0,
	0,0,	389,475,	0,0,	0,0,
	483,484,	0,0,	485,486,	0,0,
	366,446,	443,443,	366,447,	452,533,
	366,448,	487,560,	386,388,	366,449,
	488,561,	489,562,	490,491,	366,450,
	493,565,	492,564,	366,451,	494,566,
	389,475,	366,452,	366,453,	452,534,
	473,475,	366,454,	386,473,	386,473,
	386,473,	386,473,	386,473,	386,473,
	386,473,	386,473,	386,473,	386,473,
	389,476,	389,476,	389,476,	389,476,
	389,476,	389,476,	389,476,	389,476,
	389,476,	389,476,	443,521,	473,475,
	495,567,	496,568,	497,497,	494,566,
	499,569,	500,500,	502,570,	503,571,
	504,504,	507,574,	508,575,	506,572,
	443,522,	513,576,	509,509,	473,549,
	473,549,	473,549,	473,549,	473,549,
	473,549,	473,549,	473,549,	473,549,
	473,549,	511,511,	514,577,	515,578,
	518,518,	519,580,	443,521,	497,498,
	495,567,	496,568,	500,501,	520,581,
	499,569,	504,505,	502,570,	503,571,
	506,573,	507,574,	508,575,	509,510,
	443,522,	513,576,	521,583,	522,584,
	524,586,	525,587,	527,588,	548,607,
	528,589,	530,590,	511,512,	531,591,
	532,592,	533,593,	514,577,	515,149,
	534,594,	519,580,	535,595,	536,596,
	518,579,	537,597,	538,598,	539,599,
	540,600,	541,601,	542,602,	543,603,
	544,604,	545,605,	546,606,	0,0,
	0,0,	0,0,	521,583,	522,584,
	524,586,	525,587,	527,588,	520,582,
	528,589,	530,590,	548,608,	531,591,
	532,592,	533,593,	551,609,	515,149,
	534,594,	552,611,	535,595,	536,596,
	518,579,	537,597,	538,598,	539,599,
	540,600,	541,601,	542,602,	543,603,
	544,604,	545,605,	546,606,	553,553,
	555,555,	557,613,	558,558,	560,615,
	561,616,	562,617,	565,619,	520,582,
	563,563,	0,0,	548,608,	551,610,
	566,620,	567,622,	552,612,	568,624,
	569,625,	570,626,	571,627,	581,581,
	0,0,	575,630,	572,572,	574,628,
	576,631,	577,632,	579,633,	580,634,
	553,554,	555,556,	557,614,	558,559,
	582,636,	584,637,	562,618,	560,615,
	561,616,	563,564,	565,619,	586,638,
	587,639,	566,621,	567,623,	588,640,
	589,641,	590,642,	591,643,	568,624,
	569,625,	570,626,	571,627,	572,573,
	574,629,	575,630,	592,644,	593,645,
	576,631,	577,632,	579,633,	580,634,
	594,646,	595,647,	596,648,	597,649,
	582,636,	584,637,	598,650,	581,635,
	599,651,	600,652,	601,653,	586,638,
	587,639,	602,654,	603,655,	588,640,
	589,641,	590,642,	591,643,	604,656,
	606,657,	607,607,	608,659,	615,660,
	609,609,	0,0,	592,644,	593,645,
	611,611,	613,613,	616,661,	617,617,
	594,646,	595,647,	596,648,	597,649,
	619,662,	620,620,	598,650,	581,635,
	599,651,	600,652,	601,653,	622,622,
	624,664,	602,654,	603,655,	625,665,
	626,666,	627,667,	631,670,	604,656,
	606,657,	609,610,	608,659,	615,660,
	607,658,	611,612,	613,614,	632,671,
	617,618,	628,628,	616,661,	630,668,
	633,672,	619,663,	620,621,	634,673,
	635,674,	636,675,	637,676,	638,677,
	622,623,	639,678,	640,679,	641,680,
	624,664,	642,681,	643,682,	625,665,
	626,666,	627,667,	631,670,	644,683,
	645,684,	646,685,	648,686,	649,678,
	607,658,	650,688,	628,629,	632,671,
	630,669,	651,689,	652,690,	653,691,
	633,672,	654,692,	655,693,	634,673,
	635,674,	636,675,	637,676,	638,677,
	656,694,	639,678,	640,679,	641,680,
	658,695,	642,681,	643,682,	659,696,
	660,697,	661,698,	665,702,	644,683,
	645,684,	646,685,	648,686,	662,662,
	664,700,	650,688,	666,703,	649,687,
	667,704,	651,689,	652,690,	653,691,
	668,668,	654,692,	655,693,	670,705,
	672,706,	674,707,	675,708,	676,709,
	656,694,	678,678,	679,711,	680,712,
	658,695,	0,0,	661,699,	659,696,
	660,697,	681,713,	665,702,	682,714,
	662,663,	664,701,	683,715,	684,716,
	685,717,	687,718,	666,703,	649,687,
	667,704,	668,669,	689,719,	690,720,
	692,721,	694,722,	695,723,	670,705,
	672,706,	674,707,	675,708,	676,709,
	696,724,	697,725,	679,711,	680,712,
	698,698,	678,710,	700,700,	702,727,
	703,729,	681,713,	704,730,	682,714,
	707,732,	708,733,	683,715,	684,716,
	685,717,	687,718,	710,734,	712,735,
	713,736,	715,737,	689,719,	690,720,
	692,721,	694,722,	695,723,	717,738,
	718,739,	719,740,	697,726,	720,741,
	696,724,	698,699,	722,742,	700,701,
	702,728,	678,710,	723,743,	725,725,
	703,729,	730,746,	704,730,	727,727,
	707,732,	708,733,	729,744,	732,747,
	733,748,	734,749,	710,734,	712,735,
	713,736,	715,737,	735,750,	736,751,
	738,752,	739,753,	741,754,	717,738,
	718,739,	719,740,	742,755,	720,741,
	744,744,	747,758,	722,742,	746,756,
	725,726,	748,759,	723,743,	749,760,
	727,728,	730,746,	751,761,	729,745,
	752,762,	755,763,	756,756,	732,747,
	733,748,	734,749,	758,764,	759,765,
	762,766,	764,767,	735,750,	736,751,
	738,752,	739,753,	741,754,	765,768,
	767,769,	744,745,	742,755,	0,0,
	746,757,	747,758,	0,0,	0,0,
	0,0,	748,759,	0,0,	749,760,
	0,0,	0,0,	751,761,	756,757,
	752,762,	755,763,	0,0,	0,0,
	0,0,	0,0,	758,764,	759,765,
	762,766,	764,767,	0,0,	0,0,
	0,0,	0,0,	0,0,	765,768,
	767,769,	0,0};
struct yysvf yysvec[] = {
0,	0,	0,
yycrank+1,	0,		0,	
yycrank+115,	yysvec+1,	0,	
yycrank+108,	yysvec+1,	0,	
yycrank+202,	yysvec+1,	0,	
yycrank+0,	yysvec+1,	0,	
yycrank+296,	yysvec+1,	0,	
yycrank+257,	yysvec+1,	0,	
yycrank+351,	yysvec+1,	0,	
yycrank+402,	yysvec+1,	0,	
yycrank+482,	yysvec+1,	0,	
yycrank+504,	yysvec+1,	0,	
yycrank+584,	yysvec+1,	0,	
yycrank+116,	yysvec+1,	0,	
yycrank+655,	yysvec+1,	0,	
yycrank+131,	yysvec+1,	0,	
yycrank+725,	yysvec+1,	0,	
yycrank+191,	yysvec+1,	0,	
yycrank+795,	yysvec+1,	0,	
yycrank+192,	yysvec+1,	0,	
yycrank+865,	yysvec+1,	0,	
yycrank+888,	yysvec+1,	0,	
yycrank+974,	yysvec+1,	0,	
yycrank+0,	yysvec+1,	0,	
yycrank+1059,	yysvec+1,	0,	
yycrank+11,	yysvec+1,	0,	
yycrank+1095,	yysvec+1,	0,	
yycrank+1114,	yysvec+1,	0,	
yycrank+1228,	yysvec+1,	0,	
yycrank+60,	yysvec+1,	0,	
yycrank+1342,	yysvec+1,	0,	
yycrank+0,	0,		yyvstop+1,
yycrank+0,	0,		yyvstop+3,
yycrank+-1404,	0,		0,	
yycrank+-1495,	0,		0,	
yycrank+0,	0,		yyvstop+5,
yycrank+122,	0,		0,	
yycrank+-1586,	0,		0,	
yycrank+18,	0,		yyvstop+7,
yycrank+0,	0,		yyvstop+9,
yycrank+50,	0,		yyvstop+11,
yycrank+0,	0,		yyvstop+13,
yycrank+95,	0,		yyvstop+15,
yycrank+0,	0,		yyvstop+17,
yycrank+1638,	0,		yyvstop+19,
yycrank+88,	0,		yyvstop+21,
yycrank+696,	0,		yyvstop+23,
yycrank+35,	0,		yyvstop+25,
yycrank+0,	0,		yyvstop+27,
yycrank+34,	0,		yyvstop+29,
yycrank+72,	0,		yyvstop+31,
yycrank+36,	0,		yyvstop+33,
yycrank+0,	0,		yyvstop+35,
yycrank+1725,	0,		yyvstop+37,
yycrank+107,	yysvec+53,	yyvstop+39,
yycrank+51,	yysvec+53,	yyvstop+41,
yycrank+116,	yysvec+53,	yyvstop+43,
yycrank+73,	yysvec+53,	yyvstop+45,
yycrank+118,	yysvec+53,	yyvstop+47,
yycrank+125,	yysvec+53,	yyvstop+49,
yycrank+138,	yysvec+53,	yyvstop+51,
yycrank+105,	yysvec+53,	yyvstop+53,
yycrank+145,	yysvec+53,	yyvstop+55,
yycrank+106,	yysvec+53,	yyvstop+57,
yycrank+117,	0,		yyvstop+59,
yycrank+1839,	0,		yyvstop+61,
yycrank+0,	0,		yyvstop+63,
yycrank+-1896,	0,		0,	
yycrank+0,	yysvec+36,	yyvstop+66,
yycrank+269,	0,		yyvstop+68,
yycrank+1978,	yysvec+46,	yyvstop+70,
yycrank+127,	yysvec+53,	yyvstop+72,
yycrank+172,	yysvec+53,	yyvstop+74,
yycrank+175,	yysvec+53,	yyvstop+76,
yycrank+256,	yysvec+53,	yyvstop+78,
yycrank+353,	yysvec+53,	yyvstop+80,
yycrank+490,	yysvec+53,	yyvstop+82,
yycrank+262,	yysvec+53,	yyvstop+84,
yycrank+287,	yysvec+53,	yyvstop+86,
yycrank+344,	yysvec+53,	yyvstop+88,
yycrank+276,	yysvec+53,	yyvstop+90,
yycrank+317,	yysvec+53,	yyvstop+92,
yycrank+193,	yysvec+53,	yyvstop+94,
yycrank+197,	yysvec+53,	yyvstop+96,
yycrank+208,	yysvec+53,	yyvstop+98,
yycrank+206,	yysvec+53,	yyvstop+100,
yycrank+267,	yysvec+53,	yyvstop+102,
yycrank+346,	yysvec+53,	yyvstop+104,
yycrank+566,	yysvec+53,	yyvstop+106,
yycrank+365,	yysvec+53,	yyvstop+108,
yycrank+301,	yysvec+53,	yyvstop+110,
yycrank+274,	yysvec+53,	yyvstop+112,
yycrank+393,	yysvec+53,	yyvstop+114,
yycrank+313,	yysvec+53,	yyvstop+116,
yycrank+326,	yysvec+53,	yyvstop+118,
yycrank+0,	yysvec+38,	yyvstop+120,
yycrank+0,	0,		yyvstop+123,
yycrank+0,	yysvec+42,	yyvstop+126,
yycrank+369,	yysvec+53,	yyvstop+129,
yycrank+707,	yysvec+53,	yyvstop+131,
yycrank+373,	yysvec+53,	yyvstop+133,
yycrank+396,	yysvec+53,	yyvstop+135,
yycrank+405,	yysvec+53,	yyvstop+137,
yycrank+420,	yysvec+53,	yyvstop+139,
yycrank+409,	yysvec+53,	yyvstop+141,
yycrank+833,	yysvec+53,	yyvstop+143,
yycrank+1963,	yysvec+53,	yyvstop+147,
yycrank+1306,	yysvec+53,	yyvstop+150,
yycrank+1802,	yysvec+53,	yyvstop+153,
yycrank+1115,	yysvec+53,	yyvstop+156,
yycrank+1995,	yysvec+53,	yyvstop+159,
yycrank+-2054,	0,		yyvstop+162,
yycrank+2106,	yysvec+53,	yyvstop+165,
yycrank+1715,	yysvec+53,	yyvstop+168,
yycrank+1461,	yysvec+53,	yyvstop+171,
yycrank+0,	yysvec+53,	yyvstop+174,
yycrank+428,	yysvec+53,	yyvstop+177,
yycrank+2116,	yysvec+53,	yyvstop+180,
yycrank+0,	yysvec+53,	yyvstop+183,
yycrank+1552,	yysvec+53,	yyvstop+186,
yycrank+412,	yysvec+53,	yyvstop+189,
yycrank+2167,	0,		yyvstop+191,
yycrank+0,	yysvec+53,	yyvstop+193,
yycrank+519,	yysvec+53,	yyvstop+196,
yycrank+407,	yysvec+53,	yyvstop+199,
yycrank+535,	yysvec+53,	yyvstop+202,
yycrank+416,	yysvec+53,	yyvstop+205,
yycrank+478,	yysvec+53,	yyvstop+208,
yycrank+486,	yysvec+53,	yyvstop+211,
yycrank+501,	yysvec+53,	yyvstop+214,
yycrank+204,	yysvec+53,	yyvstop+217,
yycrank+502,	yysvec+53,	yyvstop+220,
yycrank+506,	yysvec+53,	yyvstop+223,
yycrank+342,	yysvec+53,	yyvstop+226,
yycrank+170,	yysvec+53,	yyvstop+229,
yycrank+507,	yysvec+53,	yyvstop+232,
yycrank+550,	yysvec+53,	yyvstop+235,
yycrank+511,	yysvec+53,	yyvstop+237,
yycrank+0,	0,		yyvstop+239,
yycrank+0,	0,		yyvstop+241,
yycrank+0,	0,		yyvstop+243,
yycrank+-2289,	0,		0,	
yycrank+0,	0,		yyvstop+245,
yycrank+91,	0,		yyvstop+247,
yycrank+0,	0,		yyvstop+249,
yycrank+0,	yysvec+42,	0,	
yycrank+0,	0,		yyvstop+251,
yycrank+1813,	0,		yyvstop+253,
yycrank+2334,	0,		0,	
yycrank+537,	yysvec+148,	0,	
yycrank+582,	yysvec+148,	0,	
yycrank+581,	yysvec+148,	0,	
yycrank+715,	yysvec+148,	0,	
yycrank+722,	yysvec+148,	0,	
yycrank+589,	yysvec+148,	0,	
yycrank+645,	yysvec+148,	0,	
yycrank+781,	yysvec+148,	0,	
yycrank+0,	0,		yyvstop+256,
yycrank+0,	0,		yyvstop+258,
yycrank+0,	0,		yyvstop+260,
yycrank+1191,	yysvec+147,	yyvstop+262,
yycrank+1378,	0,		0,	
yycrank+2027,	0,		0,	
yycrank+0,	0,		yyvstop+265,
yycrank+0,	0,		yyvstop+267,
yycrank+0,	0,		yyvstop+269,
yycrank+0,	0,		yyvstop+271,
yycrank+0,	0,		yyvstop+273,
yycrank+337,	0,		0,	
yycrank+391,	0,		0,	
yycrank+541,	yysvec+53,	yyvstop+275,
yycrank+565,	yysvec+53,	yyvstop+277,
yycrank+587,	yysvec+53,	yyvstop+279,
yycrank+615,	yysvec+53,	yyvstop+281,
yycrank+645,	yysvec+53,	yyvstop+283,
yycrank+709,	yysvec+53,	yyvstop+285,
yycrank+606,	yysvec+53,	yyvstop+287,
yycrank+652,	yysvec+53,	yyvstop+289,
yycrank+875,	0,		0,	
yycrank+891,	0,		0,	
yycrank+660,	yysvec+53,	yyvstop+291,
yycrank+2409,	0,		0,	
yycrank+2432,	0,		0,	
yycrank+0,	0,		yyvstop+293,
yycrank+0,	0,		yyvstop+295,
yycrank+0,	yysvec+65,	0,	
yycrank+0,	0,		yyvstop+297,
yycrank+-2503,	0,		0,	
yycrank+0,	0,		yyvstop+299,
yycrank+2585,	0,		0,	
yycrank+670,	0,		0,	
yycrank+0,	0,		yyvstop+301,
yycrank+-2611,	0,		0,	
yycrank+0,	0,		yyvstop+304,
yycrank+0,	yysvec+189,	yyvstop+306,
yycrank+2693,	yysvec+46,	yyvstop+308,
yycrank+722,	yysvec+53,	yyvstop+310,
yycrank+757,	yysvec+53,	yyvstop+312,
yycrank+743,	yysvec+53,	yyvstop+314,
yycrank+726,	yysvec+53,	yyvstop+316,
yycrank+721,	yysvec+53,	yyvstop+318,
yycrank+747,	yysvec+53,	yyvstop+320,
yycrank+787,	yysvec+53,	yyvstop+322,
yycrank+791,	yysvec+53,	yyvstop+324,
yycrank+787,	yysvec+53,	yyvstop+326,
yycrank+796,	yysvec+53,	yyvstop+328,
yycrank+793,	yysvec+53,	yyvstop+330,
yycrank+788,	yysvec+53,	yyvstop+332,
yycrank+801,	yysvec+53,	yyvstop+334,
yycrank+836,	yysvec+53,	yyvstop+336,
yycrank+863,	yysvec+53,	yyvstop+338,
yycrank+850,	yysvec+53,	yyvstop+340,
yycrank+952,	yysvec+53,	yyvstop+342,
yycrank+957,	yysvec+53,	yyvstop+344,
yycrank+932,	yysvec+53,	yyvstop+346,
yycrank+875,	yysvec+53,	yyvstop+348,
yycrank+996,	yysvec+53,	yyvstop+350,
yycrank+867,	yysvec+53,	yyvstop+352,
yycrank+872,	yysvec+53,	yyvstop+354,
yycrank+895,	yysvec+53,	yyvstop+356,
yycrank+904,	yysvec+53,	yyvstop+358,
yycrank+904,	yysvec+53,	yyvstop+360,
yycrank+1033,	yysvec+53,	yyvstop+362,
yycrank+934,	yysvec+53,	yyvstop+364,
yycrank+967,	yysvec+53,	yyvstop+366,
yycrank+966,	yysvec+53,	yyvstop+368,
yycrank+971,	yysvec+53,	yyvstop+370,
yycrank+1023,	yysvec+53,	yyvstop+372,
yycrank+1035,	yysvec+53,	yyvstop+374,
yycrank+1013,	yysvec+53,	yyvstop+376,
yycrank+1056,	yysvec+53,	yyvstop+378,
yycrank+1201,	yysvec+53,	yyvstop+380,
yycrank+1316,	yysvec+53,	yyvstop+383,
yycrank+0,	yysvec+53,	yyvstop+386,
yycrank+0,	yysvec+53,	yyvstop+389,
yycrank+2126,	yysvec+53,	yyvstop+392,
yycrank+2152,	yysvec+53,	yyvstop+395,
yycrank+2252,	yysvec+53,	yyvstop+398,
yycrank+2262,	yysvec+53,	yyvstop+401,
yycrank+2341,	yysvec+53,	yyvstop+404,
yycrank+2466,	yysvec+53,	yyvstop+407,
yycrank+-2719,	0,		yyvstop+410,
yycrank+2574,	yysvec+53,	yyvstop+412,
yycrank+2682,	yysvec+53,	yyvstop+415,
yycrank+2771,	yysvec+53,	yyvstop+418,
yycrank+0,	yysvec+53,	yyvstop+421,
yycrank+0,	yysvec+53,	yyvstop+424,
yycrank+2781,	yysvec+53,	yyvstop+427,
yycrank+2791,	yysvec+53,	yyvstop+430,
yycrank+2801,	yysvec+53,	yyvstop+433,
yycrank+2811,	yysvec+53,	yyvstop+436,
yycrank+1041,	yysvec+53,	yyvstop+439,
yycrank+2837,	0,		0,	
yycrank+1230,	0,		0,	
yycrank+1059,	yysvec+53,	yyvstop+441,
yycrank+1060,	yysvec+53,	yyvstop+443,
yycrank+1052,	yysvec+53,	yyvstop+445,
yycrank+1211,	yysvec+53,	yyvstop+447,
yycrank+0,	0,		yyvstop+449,
yycrank+0,	0,		yyvstop+451,
yycrank+2827,	0,		0,	
yycrank+2842,	0,		0,	
yycrank+0,	0,		yyvstop+453,
yycrank+1308,	yysvec+148,	0,	
yycrank+1421,	yysvec+148,	0,	
yycrank+1098,	yysvec+148,	0,	
yycrank+1213,	yysvec+148,	0,	
yycrank+1243,	yysvec+148,	0,	
yycrank+1341,	yysvec+148,	0,	
yycrank+1420,	yysvec+148,	0,	
yycrank+1511,	yysvec+148,	0,	
yycrank+1442,	yysvec+148,	0,	
yycrank+1567,	yysvec+148,	0,	
yycrank+1423,	yysvec+148,	0,	
yycrank+2912,	0,		0,	
yycrank+0,	yysvec+274,	yyvstop+455,
yycrank+2922,	0,		0,	
yycrank+0,	yysvec+276,	yyvstop+457,
yycrank+116,	yysvec+168,	0,	
yycrank+119,	yysvec+169,	0,	
yycrank+1108,	yysvec+53,	yyvstop+459,
yycrank+1222,	yysvec+53,	yyvstop+461,
yycrank+1221,	yysvec+53,	yyvstop+463,
yycrank+2948,	yysvec+53,	yyvstop+465,
yycrank+1514,	0,		0,	
yycrank+1300,	yysvec+53,	yyvstop+467,
yycrank+1567,	0,		0,	
yycrank+1298,	yysvec+53,	yyvstop+469,
yycrank+1320,	yysvec+53,	yyvstop+471,
yycrank+398,	yysvec+53,	yyvstop+473,
yycrank+127,	yysvec+178,	0,	
yycrank+164,	yysvec+179,	0,	
yycrank+1338,	yysvec+53,	yyvstop+475,
yycrank+203,	yysvec+181,	0,	
yycrank+206,	yysvec+182,	0,	
yycrank+0,	0,		yyvstop+477,
yycrank+2988,	0,		0,	
yycrank+1351,	0,		0,	
yycrank+0,	0,		yyvstop+479,
yycrank+0,	yysvec+296,	yyvstop+481,
yycrank+3020,	yysvec+46,	yyvstop+483,
yycrank+1445,	yysvec+53,	yyvstop+485,
yycrank+1453,	yysvec+53,	yyvstop+487,
yycrank+1450,	yysvec+53,	yyvstop+489,
yycrank+1512,	yysvec+53,	yyvstop+491,
yycrank+1538,	yysvec+53,	yyvstop+493,
yycrank+1543,	yysvec+53,	yyvstop+495,
yycrank+529,	yysvec+53,	yyvstop+497,
yycrank+1533,	yysvec+53,	yyvstop+499,
yycrank+1548,	yysvec+53,	yyvstop+501,
yycrank+1573,	yysvec+53,	yyvstop+503,
yycrank+1628,	yysvec+53,	yyvstop+505,
yycrank+1614,	yysvec+53,	yyvstop+507,
yycrank+1630,	yysvec+53,	yyvstop+509,
yycrank+1616,	yysvec+53,	yyvstop+511,
yycrank+1635,	yysvec+53,	yyvstop+513,
yycrank+1624,	yysvec+53,	yyvstop+515,
yycrank+664,	yysvec+53,	yyvstop+517,
yycrank+1712,	yysvec+53,	yyvstop+519,
yycrank+1718,	yysvec+53,	yyvstop+521,
yycrank+1711,	yysvec+53,	yyvstop+523,
yycrank+1704,	yysvec+53,	yyvstop+525,
yycrank+1796,	yysvec+53,	yyvstop+527,
yycrank+1792,	yysvec+53,	yyvstop+529,
yycrank+1795,	yysvec+53,	yyvstop+531,
yycrank+1833,	yysvec+53,	yyvstop+533,
yycrank+1806,	yysvec+53,	yyvstop+535,
yycrank+1800,	yysvec+53,	yyvstop+537,
yycrank+1821,	yysvec+53,	yyvstop+539,
yycrank+3017,	yysvec+53,	yyvstop+541,
yycrank+682,	yysvec+53,	yyvstop+543,
yycrank+734,	yysvec+53,	yyvstop+545,
yycrank+804,	yysvec+53,	yyvstop+547,
yycrank+874,	yysvec+53,	yyvstop+549,
yycrank+1830,	yysvec+53,	yyvstop+551,
yycrank+2933,	yysvec+53,	yyvstop+553,
yycrank+2950,	yysvec+53,	yyvstop+556,
yycrank+3057,	yysvec+53,	yyvstop+559,
yycrank+3089,	yysvec+53,	yyvstop+562,
yycrank+1816,	yysvec+53,	yyvstop+565,
yycrank+0,	0,		yyvstop+567,
yycrank+1826,	yysvec+53,	yyvstop+569,
yycrank+1843,	yysvec+53,	yyvstop+571,
yycrank+1853,	yysvec+53,	yyvstop+573,
yycrank+1838,	yysvec+53,	yyvstop+575,
yycrank+3099,	0,		0,	
yycrank+0,	yysvec+345,	yyvstop+577,
yycrank+3109,	0,		0,	
yycrank+0,	yysvec+347,	yyvstop+579,
yycrank+1878,	yysvec+148,	0,	
yycrank+0,	0,		yyvstop+581,
yycrank+1880,	yysvec+148,	0,	
yycrank+2035,	yysvec+148,	0,	
yycrank+0,	0,		yyvstop+584,
yycrank+0,	0,		yyvstop+587,
yycrank+0,	0,		yyvstop+590,
yycrank+0,	0,		yyvstop+593,
yycrank+0,	0,		yyvstop+596,
yycrank+1981,	yysvec+148,	0,	
yycrank+1881,	yysvec+148,	0,	
yycrank+0,	0,		yyvstop+599,
yycrank+1991,	yysvec+148,	0,	
yycrank+0,	0,		yyvstop+602,
yycrank+1885,	yysvec+53,	yyvstop+604,
yycrank+1913,	yysvec+53,	yyvstop+606,
yycrank+2960,	yysvec+53,	yyvstop+608,
yycrank+3102,	0,		0,	
yycrank+1917,	yysvec+53,	yyvstop+610,
yycrank+1925,	yysvec+53,	yyvstop+612,
yycrank+2106,	yysvec+53,	yyvstop+614,
yycrank+2116,	yysvec+53,	yyvstop+616,
yycrank+1926,	yysvec+53,	yyvstop+618,
yycrank+1924,	yysvec+53,	yyvstop+620,
yycrank+1939,	yysvec+53,	yyvstop+622,
yycrank+1933,	yysvec+53,	yyvstop+624,
yycrank+1985,	yysvec+53,	yyvstop+626,
yycrank+1989,	0,		0,	
yycrank+0,	yysvec+53,	yyvstop+628,
yycrank+2029,	0,		0,	
yycrank+2032,	yysvec+53,	yyvstop+631,
yycrank+1345,	yysvec+53,	yyvstop+633,
yycrank+1380,	0,		0,	
yycrank+0,	0,		yyvstop+635,
yycrank+0,	0,		yyvstop+637,
yycrank+2120,	yysvec+53,	yyvstop+639,
yycrank+0,	0,		yyvstop+641,
yycrank+3174,	0,		0,	
yycrank+2112,	0,		0,	
yycrank+0,	yysvec+386,	yyvstop+643,
yycrank+3184,	yysvec+46,	yyvstop+645,
yycrank+0,	yysvec+53,	yyvstop+647,
yycrank+2106,	yysvec+53,	yyvstop+650,
yycrank+2111,	yysvec+53,	yyvstop+652,
yycrank+2118,	yysvec+53,	yyvstop+654,
yycrank+2118,	yysvec+53,	yyvstop+656,
yycrank+2129,	yysvec+53,	yyvstop+658,
yycrank+1436,	0,		0,	
yycrank+0,	0,		yyvstop+660,
yycrank+2113,	yysvec+53,	yyvstop+662,
yycrank+1487,	yysvec+53,	yyvstop+664,
yycrank+2230,	yysvec+53,	yyvstop+666,
yycrank+2153,	yysvec+53,	yyvstop+668,
yycrank+2195,	yysvec+53,	yyvstop+670,
yycrank+2495,	yysvec+53,	yyvstop+672,
yycrank+2179,	yysvec+53,	yyvstop+674,
yycrank+2225,	yysvec+53,	yyvstop+676,
yycrank+2280,	yysvec+53,	yyvstop+678,
yycrank+1527,	0,		0,	
yycrank+0,	0,		yyvstop+680,
yycrank+2267,	yysvec+53,	yyvstop+682,
yycrank+2586,	yysvec+53,	yyvstop+684,
yycrank+1578,	yysvec+53,	yyvstop+686,
yycrank+2284,	yysvec+53,	yyvstop+688,
yycrank+2389,	yysvec+53,	yyvstop+690,
yycrank+1842,	yysvec+53,	yyvstop+692,
yycrank+2404,	yysvec+53,	yyvstop+694,
yycrank+1888,	yysvec+53,	yyvstop+696,
yycrank+2407,	yysvec+53,	yyvstop+698,
yycrank+2415,	yysvec+53,	yyvstop+700,
yycrank+1962,	yysvec+366,	0,	
yycrank+0,	0,		yyvstop+702,
yycrank+2026,	0,		0,	
yycrank+0,	0,		yyvstop+704,
yycrank+2264,	0,		0,	
yycrank+0,	0,		yyvstop+706,
yycrank+2435,	0,		0,	
yycrank+0,	0,		yyvstop+708,
yycrank+2494,	0,		0,	
yycrank+0,	0,		yyvstop+710,
yycrank+2496,	yysvec+53,	yyvstop+712,
yycrank+2504,	yysvec+53,	yyvstop+714,
yycrank+0,	yysvec+53,	yyvstop+716,
yycrank+0,	yysvec+53,	yyvstop+719,
yycrank+2488,	yysvec+53,	yyvstop+723,
yycrank+2498,	yysvec+53,	yyvstop+725,
yycrank+0,	0,		yyvstop+727,
yycrank+0,	0,		yyvstop+730,
yycrank+3015,	yysvec+148,	0,	
yycrank+2554,	yysvec+148,	0,	
yycrank+0,	0,		yyvstop+733,
yycrank+2662,	yysvec+148,	0,	
yycrank+2959,	yysvec+53,	yyvstop+736,
yycrank+2545,	yysvec+53,	yyvstop+738,
yycrank+3169,	0,		0,	
yycrank+2546,	yysvec+53,	yyvstop+740,
yycrank+2599,	yysvec+53,	yyvstop+742,
yycrank+2598,	0,		0,	
yycrank+2596,	0,		0,	
yycrank+2945,	0,		0,	
yycrank+2956,	0,		0,	
yycrank+2643,	0,		0,	
yycrank+2641,	0,		0,	
yycrank+3102,	0,		0,	
yycrank+2635,	0,		0,	
yycrank+2706,	0,		0,	
yycrank+2700,	yysvec+53,	yyvstop+744,
yycrank+0,	yysvec+53,	yyvstop+746,
yycrank+2699,	yysvec+53,	yyvstop+749,
yycrank+2704,	yysvec+53,	yyvstop+751,
yycrank+0,	yysvec+53,	yyvstop+753,
yycrank+2699,	yysvec+53,	yyvstop+756,
yycrank+2832,	yysvec+53,	yyvstop+758,
yycrank+2822,	yysvec+53,	yyvstop+760,
yycrank+2943,	yysvec+53,	yyvstop+762,
yycrank+2956,	yysvec+53,	yyvstop+764,
yycrank+2943,	yysvec+53,	yyvstop+766,
yycrank+3017,	yysvec+53,	yyvstop+768,
yycrank+0,	0,		yyvstop+770,
yycrank+3004,	0,		0,	
yycrank+0,	yysvec+53,	yyvstop+772,
yycrank+2583,	0,		0,	
yycrank+0,	0,		yyvstop+775,
yycrank+3005,	yysvec+53,	yyvstop+777,
yycrank+3211,	0,		0,	
yycrank+0,	0,		yyvstop+779,
yycrank+0,	yysvec+473,	yyvstop+781,
yycrank+451,	yysvec+46,	yyvstop+783,
yycrank+3008,	yysvec+53,	yyvstop+785,
yycrank+3014,	yysvec+53,	yyvstop+787,
yycrank+3066,	yysvec+53,	yyvstop+789,
yycrank+3067,	yysvec+53,	yyvstop+791,
yycrank+3019,	yysvec+53,	yyvstop+793,
yycrank+3070,	yysvec+53,	yyvstop+795,
yycrank+3135,	0,		0,	
yycrank+0,	0,		yyvstop+797,
yycrank+3137,	0,		0,	
yycrank+0,	0,		yyvstop+799,
yycrank+3089,	yysvec+53,	yyvstop+801,
yycrank+3105,	yysvec+53,	yyvstop+803,
yycrank+3093,	yysvec+53,	yyvstop+805,
yycrank+3149,	0,		0,	
yycrank+0,	0,		yyvstop+807,
yycrank+3152,	yysvec+53,	yyvstop+809,
yycrank+3111,	yysvec+53,	yyvstop+811,
yycrank+3133,	yysvec+53,	yyvstop+813,
yycrank+3176,	yysvec+53,	yyvstop+815,
yycrank+3172,	yysvec+53,	yyvstop+817,
yycrank+3214,	0,		0,	
yycrank+0,	0,		yyvstop+819,
yycrank+3166,	yysvec+53,	yyvstop+821,
yycrank+3217,	0,		0,	
yycrank+0,	0,		yyvstop+823,
yycrank+3172,	yysvec+53,	yyvstop+825,
yycrank+3174,	yysvec+53,	yyvstop+827,
yycrank+3220,	0,		0,	
yycrank+0,	0,		yyvstop+829,
yycrank+3223,	yysvec+53,	yyvstop+831,
yycrank+3170,	yysvec+53,	yyvstop+833,
yycrank+3187,	yysvec+53,	yyvstop+835,
yycrank+3226,	0,		0,	
yycrank+0,	0,		yyvstop+837,
yycrank+3237,	0,		0,	
yycrank+0,	0,		yyvstop+839,
yycrank+3174,	yysvec+53,	yyvstop+841,
yycrank+3192,	yysvec+53,	yyvstop+843,
yycrank+3225,	yysvec+148,	0,	
yycrank+0,	0,		yyvstop+845,
yycrank+0,	0,		yyvstop+848,
yycrank+3240,	0,		0,	
yycrank+3208,	yysvec+53,	yyvstop+851,
yycrank+3247,	yysvec+53,	yyvstop+853,
yycrank+3220,	0,		0,	
yycrank+3219,	0,		0,	
yycrank+251,	yysvec+53,	yyvstop+855,
yycrank+3223,	yysvec+53,	yyvstop+857,
yycrank+3214,	0,		0,	
yycrank+0,	0,		yyvstop+859,
yycrank+3212,	0,		0,	
yycrank+3218,	0,		0,	
yycrank+0,	0,		yyvstop+861,
yycrank+3213,	0,		0,	
yycrank+3231,	0,		0,	
yycrank+3221,	0,		0,	
yycrank+3225,	0,		0,	
yycrank+3238,	0,		0,	
yycrank+3226,	0,		0,	
yycrank+3238,	0,		0,	
yycrank+3242,	yysvec+53,	yyvstop+863,
yycrank+3245,	yysvec+53,	yyvstop+865,
yycrank+3244,	yysvec+53,	yyvstop+867,
yycrank+3243,	yysvec+53,	yyvstop+869,
yycrank+3228,	yysvec+53,	yyvstop+871,
yycrank+3243,	yysvec+53,	yyvstop+873,
yycrank+3246,	yysvec+53,	yyvstop+875,
yycrank+3234,	yysvec+53,	yyvstop+877,
yycrank+3248,	yysvec+53,	yyvstop+879,
yycrank+3236,	yysvec+53,	yyvstop+881,
yycrank+0,	0,		yyvstop+883,
yycrank+3263,	yysvec+53,	yyvstop+885,
yycrank+470,	0,		0,	
yycrank+0,	yysvec+549,	yyvstop+887,
yycrank+3302,	yysvec+53,	yyvstop+889,
yycrank+3305,	yysvec+53,	yyvstop+891,
yycrank+3319,	0,		0,	
yycrank+0,	0,		yyvstop+893,
yycrank+3320,	0,		0,	
yycrank+0,	0,		yyvstop+895,
yycrank+3321,	yysvec+53,	yyvstop+897,
yycrank+3322,	0,		0,	
yycrank+0,	0,		yyvstop+899,
yycrank+3271,	yysvec+53,	yyvstop+901,
yycrank+3272,	yysvec+53,	yyvstop+903,
yycrank+3325,	yysvec+53,	yyvstop+905,
yycrank+3328,	0,		0,	
yycrank+0,	0,		yyvstop+907,
yycrank+3291,	yysvec+53,	yyvstop+909,
yycrank+3332,	yysvec+53,	yyvstop+911,
yycrank+3333,	yysvec+53,	yyvstop+913,
yycrank+3288,	yysvec+53,	yyvstop+915,
yycrank+3295,	yysvec+53,	yyvstop+917,
yycrank+3285,	yysvec+53,	yyvstop+919,
yycrank+3305,	yysvec+53,	yyvstop+921,
yycrank+3342,	0,		0,	
yycrank+0,	0,		yyvstop+923,
yycrank+3343,	yysvec+53,	yyvstop+925,
yycrank+3304,	yysvec+53,	yyvstop+927,
yycrank+3303,	yysvec+53,	yyvstop+929,
yycrank+3310,	yysvec+53,	yyvstop+931,
yycrank+0,	0,		yyvstop+933,
yycrank+3313,	0,		0,	
yycrank+3295,	yysvec+53,	yyvstop+936,
yycrank+3339,	0,		0,	
yycrank+3302,	yysvec+53,	yyvstop+938,
yycrank+458,	0,		0,	
yycrank+3316,	0,		0,	
yycrank+0,	0,		yyvstop+940,
yycrank+3309,	yysvec+53,	yyvstop+942,
yycrank+3325,	0,		0,	
yycrank+3330,	0,		0,	
yycrank+3329,	0,		0,	
yycrank+3328,	0,		0,	
yycrank+3313,	0,		0,	
yycrank+3335,	0,		0,	
yycrank+3338,	0,		0,	
yycrank+3330,	0,		0,	
yycrank+3344,	0,		0,	
yycrank+3332,	0,		0,	
yycrank+3340,	yysvec+53,	yyvstop+944,
yycrank+3342,	yysvec+53,	yyvstop+946,
yycrank+3336,	yysvec+53,	yyvstop+948,
yycrank+3339,	yysvec+53,	yyvstop+950,
yycrank+3346,	yysvec+53,	yyvstop+952,
yycrank+3343,	yysvec+53,	yyvstop+954,
yycrank+3359,	yysvec+53,	yyvstop+956,
yycrank+3352,	yysvec+53,	yyvstop+958,
yycrank+0,	yysvec+53,	yyvstop+960,
yycrank+3363,	yysvec+53,	yyvstop+963,
yycrank+3401,	0,		0,	
yycrank+3369,	yysvec+53,	yyvstop+965,
yycrank+3404,	0,		0,	
yycrank+0,	0,		yyvstop+967,
yycrank+3408,	0,		0,	
yycrank+0,	0,		yyvstop+969,
yycrank+3409,	0,		0,	
yycrank+0,	0,		yyvstop+971,
yycrank+3366,	yysvec+53,	yyvstop+973,
yycrank+3370,	yysvec+53,	yyvstop+975,
yycrank+3411,	0,		0,	
yycrank+0,	0,		yyvstop+977,
yycrank+3416,	yysvec+53,	yyvstop+979,
yycrank+3417,	0,		0,	
yycrank+0,	0,		yyvstop+981,
yycrank+3423,	0,		0,	
yycrank+0,	0,		yyvstop+983,
yycrank+3378,	yysvec+53,	yyvstop+985,
yycrank+3375,	yysvec+53,	yyvstop+987,
yycrank+3387,	yysvec+53,	yyvstop+989,
yycrank+3377,	yysvec+53,	yyvstop+991,
yycrank+3441,	0,		0,	
yycrank+0,	0,		yyvstop+993,
yycrank+3443,	yysvec+53,	yyvstop+995,
yycrank+3383,	yysvec+53,	yyvstop+997,
yycrank+3402,	yysvec+53,	yyvstop+999,
yycrank+3392,	0,		0,	
yycrank+3414,	yysvec+53,	yyvstop+1001,
yycrank+3398,	0,		0,	
yycrank+3412,	yysvec+53,	yyvstop+1003,
yycrank+3400,	0,		0,	
yycrank+3414,	yysvec+53,	yyvstop+1005,
yycrank+3410,	0,		0,	
yycrank+3410,	0,		0,	
yycrank+3403,	0,		0,	
yycrank+3407,	0,		0,	
yycrank+3414,	0,		0,	
yycrank+3413,	0,		0,	
yycrank+3429,	0,		0,	
yycrank+3418,	0,		0,	
yycrank+0,	0,		yyvstop+1007,
yycrank+3429,	0,		0,	
yycrank+3467,	yysvec+53,	yyvstop+1009,
yycrank+3425,	yysvec+53,	yyvstop+1011,
yycrank+3432,	yysvec+53,	yyvstop+1013,
yycrank+3436,	yysvec+53,	yyvstop+1015,
yycrank+3438,	yysvec+53,	yyvstop+1017,
yycrank+3444,	yysvec+53,	yyvstop+1019,
yycrank+3426,	yysvec+53,	yyvstop+1021,
yycrank+3431,	yysvec+53,	yyvstop+1023,
yycrank+0,	yysvec+53,	yyvstop+1025,
yycrank+3455,	0,		0,	
yycrank+3440,	yysvec+53,	yyvstop+1028,
yycrank+3456,	yysvec+53,	yyvstop+1030,
yycrank+3493,	yysvec+53,	yyvstop+1032,
yycrank+3499,	0,		0,	
yycrank+0,	0,		yyvstop+1034,
yycrank+3500,	yysvec+53,	yyvstop+1036,
yycrank+3457,	yysvec+53,	yyvstop+1038,
yycrank+3469,	yysvec+53,	yyvstop+1040,
yycrank+3452,	yysvec+53,	yyvstop+1042,
yycrank+3508,	0,		0,	
yycrank+0,	0,		yyvstop+1044,
yycrank+3465,	yysvec+53,	yyvstop+1046,
yycrank+0,	yysvec+53,	yyvstop+1048,
yycrank+3479,	0,		0,	
yycrank+0,	yysvec+53,	yyvstop+1051,
yycrank+3476,	0,		0,	
yycrank+3479,	yysvec+53,	yyvstop+1054,
yycrank+3478,	0,		0,	
yycrank+0,	yysvec+53,	yyvstop+1056,
yycrank+3517,	0,		0,	
yycrank+3474,	0,		0,	
yycrank+3478,	0,		0,	
yycrank+3487,	0,		0,	
yycrank+3490,	0,		0,	
yycrank+3497,	0,		0,	
yycrank+3479,	0,		0,	
yycrank+3479,	0,		0,	
yycrank+0,	0,		yyvstop+1059,
yycrank+3500,	yysvec+53,	yyvstop+1061,
yycrank+0,	yysvec+53,	yyvstop+1063,
yycrank+3491,	yysvec+53,	yyvstop+1066,
yycrank+3506,	yysvec+53,	yyvstop+1068,
yycrank+0,	yysvec+53,	yyvstop+1070,
yycrank+3495,	yysvec+53,	yyvstop+1073,
yycrank+0,	yysvec+53,	yyvstop+1075,
yycrank+3489,	yysvec+53,	yyvstop+1078,
yycrank+3491,	0,		0,	
yycrank+3511,	yysvec+53,	yyvstop+1080,
yycrank+3549,	yysvec+53,	yyvstop+1082,
yycrank+3552,	0,		0,	
yycrank+0,	0,		yyvstop+1084,
yycrank+3554,	0,		0,	
yycrank+0,	0,		yyvstop+1086,
yycrank+3555,	yysvec+53,	yyvstop+1088,
yycrank+3512,	yysvec+53,	yyvstop+1090,
yycrank+3521,	yysvec+53,	yyvstop+1092,
yycrank+207,	yysvec+53,	yyvstop+1094,
yycrank+0,	0,		yyvstop+1097,
yycrank+3525,	0,		0,	
yycrank+3520,	yysvec+53,	yyvstop+1099,
yycrank+0,	0,		yyvstop+1101,
yycrank+3533,	0,		0,	
yycrank+0,	0,		yyvstop+1103,
yycrank+3520,	0,		0,	
yycrank+3535,	0,		0,	
yycrank+0,	0,		yyvstop+1105,
yycrank+3524,	0,		0,	
yycrank+0,	0,		yyvstop+1107,
yycrank+3523,	0,		0,	
yycrank+3524,	yysvec+53,	yyvstop+1109,
yycrank+3531,	yysvec+53,	yyvstop+1111,
yycrank+3544,	yysvec+53,	yyvstop+1113,
yycrank+0,	yysvec+53,	yyvstop+1115,
yycrank+3541,	yysvec+53,	yyvstop+1118,
yycrank+3549,	0,		0,	
yycrank+0,	yysvec+53,	yyvstop+1120,
yycrank+3587,	0,		0,	
yycrank+0,	0,		yyvstop+1123,
yycrank+3591,	0,		0,	
yycrank+0,	0,		yyvstop+1125,
yycrank+3594,	yysvec+53,	yyvstop+1127,
yycrank+3553,	yysvec+53,	yyvstop+1129,
yycrank+0,	0,		yyvstop+1131,
yycrank+3554,	0,		0,	
yycrank+3545,	yysvec+53,	yyvstop+1133,
yycrank+3545,	0,		0,	
yycrank+3556,	0,		0,	
yycrank+3568,	0,		0,	
yycrank+0,	0,		yyvstop+1135,
yycrank+3563,	0,		0,	
yycrank+3572,	yysvec+53,	yyvstop+1137,
yycrank+0,	yysvec+53,	yyvstop+1139,
yycrank+3569,	yysvec+53,	yyvstop+1142,
yycrank+3564,	yysvec+53,	yyvstop+1144,
yycrank+0,	0,		yyvstop+1146,
yycrank+3612,	0,		0,	
yycrank+0,	0,		yyvstop+1148,
yycrank+3615,	yysvec+53,	yyvstop+1150,
yycrank+3562,	0,		0,	
yycrank+3576,	yysvec+53,	yyvstop+1152,
yycrank+3586,	0,		0,	
yycrank+0,	0,		yyvstop+1154,
yycrank+3585,	0,		0,	
yycrank+3578,	0,		0,	
yycrank+0,	yysvec+53,	yyvstop+1156,
yycrank+0,	yysvec+53,	yyvstop+1159,
yycrank+3588,	yysvec+53,	yyvstop+1162,
yycrank+3626,	0,		0,	
yycrank+0,	0,		yyvstop+1164,
yycrank+3589,	0,		0,	
yycrank+3584,	yysvec+53,	yyvstop+1166,
yycrank+0,	0,		yyvstop+1168,
yycrank+0,	0,		yyvstop+1170,
yycrank+3595,	0,		0,	
yycrank+0,	yysvec+53,	yyvstop+1172,
yycrank+3586,	0,		0,	
yycrank+3593,	yysvec+53,	yyvstop+1175,
yycrank+0,	0,		yyvstop+1177,
yycrank+3594,	0,		0,	
yycrank+0,	yysvec+53,	yyvstop+1179,
yycrank+0,	0,		yyvstop+1182,
0,	0,	0};
struct yywork *yytop = yycrank+3704;
struct yysvf *yybgin = yysvec+1;
unsigned char yymatch[] = {
00  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,011 ,012 ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
' ' ,01  ,'"' ,01  ,01  ,01  ,01  ,047 ,
'(' ,')' ,'*' ,'+' ,')' ,'+' ,01  ,01  ,
'0' ,'0' ,'2' ,'2' ,'2' ,'2' ,'2' ,'2' ,
'8' ,'8' ,01  ,01  ,01  ,'=' ,01  ,01  ,
01  ,'A' ,'B' ,'C' ,'D' ,'E' ,'F' ,'G' ,
'H' ,'I' ,'J' ,'K' ,'L' ,'M' ,'N' ,'O' ,
'P' ,'Q' ,'R' ,'S' ,'T' ,'U' ,'V' ,'W' ,
'X' ,'Y' ,'Z' ,01  ,01  ,01  ,01  ,01  ,
01  ,'A' ,'B' ,'c' ,'D' ,'E' ,'F' ,'G' ,
'H' ,'I' ,'J' ,'K' ,'L' ,'M' ,'N' ,'O' ,
'P' ,'Q' ,'R' ,'S' ,'T' ,'U' ,'V' ,'W' ,
'X' ,'Y' ,'Z' ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
0};
unsigned char yyextra[] = {
0,0,0,0,0,0,0,0,
0,0,0,1,0,1,1,1,
1,1,1,1,1,1,1,0,
1,1,0,1,1,1,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0};
/* @(#)44 1.9.2.3 src/bos/usr/ccs/lib/libl/ncform, libl, bos411, 9428A410j 6/2/93 13:41:00";*/
/*
 * COMPONENT_NAME: (LIBL) Lex Libraries
 *
 * FUNCTIONS: yylook, yyhlook, yyback, yyinput, yyoutput, yyunput,
 *            yymbinput, yymboutput, yymbunput, yymbreturn
 *            yywinput, yywoutput, yywunput, yywreturn
 *
 * ORIGINS: 3
 *
*/

int yylineno =1;

# define YYU(x)         x
# define NLSTATE        yyprevious=YYNEWLINE

# define YYCCLDOT       0x0001

wchar_t         yywtext[YYLMAX];
wchar_t         yywbuf[YYLMAX];

unsigned char   yytbuf[YYLMAX];
unsigned char   *yytbp;
int             yytbi;
wchar_t         yytwc;

struct yysvf    *yylstate [YYLMAX], **yylsp, **yyolsp;
unsigned char   yysbuf[YYLMAX];
unsigned char   *yysptr = yysbuf;
int             *yyfnd;
extern struct yysvf *yyestate;
int             yyprevious = YYNEWLINE;

# ifdef LEXDEBUG
int             debug;
#ifdef __cplusplus
#ifdef _CPP_IOSTREAMS
void            allprint(wchar_t);
void            sprint  (wchar_t *);
#else
extern "C" void allprint(wchar_t);
extern "C" void sprint  (wchar_t *);
#endif
#endif
# endif

yylook()
{
register struct yysvf *yystate, **yytlsp;
register struct yywork *yyt;
struct yysvf    *yyz;
int             yywch, yyfirst, yyw;
struct yywork   *yyr;
wchar_t         *yywlastch;
/*
 * start off machines
 */
# ifdef LEXDEBUG
    debug = 1;
# endif

    yyfirst=1;
    if (!yymorfg)
        yywlastch = yywtext;
    else
    {
        yymorfg=0;
        yywlastch = &(yywtext[yywleng]);
    }

    for(;;)
    {
        yytlsp = yylstate;
        yyestate = yystate = yybgin;
        if (yyprevious==YYNEWLINE)
            yystate++;
        for (;;)
        {
# ifdef LEXDEBUG
#if defined(__cplusplus) && defined(_CPP_IOSTREAMS)
            if(debug) (*yyout) << "state " << yystate-yysvec-1 << endl;
#else
            if(debug) fprintf(yyout,"state %d\n",yystate-yysvec-1);
#endif /* #if defined(__cplusplus) && defined(_CPP_IOSTREAMS) */
# endif
            yyt = yystate->yystoff;
            if(yyt == yycrank && !yyfirst)      /* may not be any transitions */
            {
                yyz = yystate->yyother;
                if(yyz == 0)
                    break;
                if(yyz->yystoff == yycrank)
                    break;
            }
            yywch = winput();
            *yywlastch++ = yywch;

            yyfirst=0;
        tryagain:
# ifdef LEXDEBUG
            if(debug)
            {
#if defined(__cplusplus) && defined(_CPP_IOSTREAMS)
                (*yyout) << "char ";
                allprint (yywch);
                (*yyout) << endl;
#else
                fprintf(yyout,"char ");
                allprint(yywch);
                putchar('\n');
#endif /* #if defined(__cplusplus) && defined(_CPP_IOSTREAMS) */
            }
# endif
            yyr = yyt;
            if ( (int)yyt > (int)yycrank)
            {
                if (yywch < NCH)                /* 8-bit */
                {
                    yyt = yyr + yywch;
                    if (yyt <= yytop && yyt->verify+yysvec == yystate)
                    {
                        if(yyt->advance+yysvec == YYLERR) /* error transitions */
                        {
                            wunput(*--yywlastch);
                            break;
                        }
                        *yytlsp++ = yystate = yyt->advance+yysvec;
                        goto contin;
                    }
                }
# if YYHSIZE
                else                            /* wide */
                {
                    if (yyw = yyhlook(yywch,yystate-yysvec))
                    {
                        if (yywcrank[yyw].wadvance+yysvec==YYLERR)
                        {
                            wunput(*--yywlastch);
                            break;
                        }
                        *yytlsp++ = yystate = yywcrank[yyw].wadvance+yysvec;
                        goto contin;
                    }
                }
# endif /*YYHSIZE*/
            }
# ifdef YYOPTIM
            else if ((int)yyt < (int)yycrank)   /* r < yycrank */
            {
                yyt = yyr = yycrank+(yycrank-yyt);
# ifdef LEXDEBUG
#if defined(__cplusplus) && defined(_CPP_IOSTREAMS)
                if(debug) (*yyout) << "compressed state" << endl;
#else
                if(debug) fprintf(yyout,"compressed state\n");
#endif /* #if defined(__cplusplus) && defined(_CPP_IOSTREAMS) */
# endif
                if (yywch < NCH)                /* 8-bit */
                {
                    yyt = yyt + yywch;
                    if(yyt <= yytop && yyt->verify+yysvec == yystate)
                    {
                        if(yyt->advance+yysvec == YYLERR) /* error transitions */
                        {
                            wunput(*--yywlastch);
                            break;
                        }
                        *yytlsp++ = yystate = yyt->advance+yysvec;
                        goto contin;
                    }
                    yyt = yyr + YYU(yymatch[yywch]);
# ifdef LEXDEBUG
                    if(debug)
                    {
#if defined(__cplusplus) && defined(_CPP_IOSTREAMS)
                        (*yyout) << "try fall back character ";
                        allprint(YYU(yymatch[yywch]));
                        (*yyout) << endl;
#else
                        fprintf(yyout,"try fall back character ");
                        allprint(YYU(yymatch[yywch]));
                        putchar('\n');
#endif /* #if defined(__cplusplus) && defined(_CPP_IOSTREAMS) */
                    }
# endif
                    if(yyt <= yytop && yyt->verify+yysvec == yystate)
                    {
                        if(yyt->advance+yysvec == YYLERR) /* error transition */
                        {
                            wunput(*--yywlastch);
                            break;
                        }
                        *yytlsp++ = yystate = yyt->advance+yysvec;
                        goto contin;
                    }
                }
# if YYHSIZE
                else                            /* wide */
                {
                    if (yyw = yyhlook(yywch,yystate-yysvec))
                    {
                        if (yywcrank[yyw].wadvance+yysvec==YYLERR)
                        {
                            wunput(*--yywlastch);
                            break;
                        }
                        *yytlsp++ = yystate = yywcrank[yyw].wadvance+yysvec;
                        goto contin;
                    }
                    if (yyw = yymlook(yywch))   /* find the target char */
                    {
                        if (yyw = yyhlook(yyw,yystate-yysvec))
                        {
                            if (yywcrank[yyw].wadvance+yysvec == YYLERR)
                            {
                                wunput(*--yywlastch);
                                break;
                            }
                            *yytlsp++ = yystate = yywcrank[yyw].wadvance+yysvec;
                            goto contin;
                        }
                    }
                }
# endif /*YYHSIZE*/
# if YYXSIZE
# ifdef MFDEBUG
                if (debug)
                {
#if defined(__cplusplus) && defined(_CPP_IOSTREAMS)
                    (*yyout) << "try extended ccl on char ";
                    allprint(YYU(yywch));
                    (*yyout) << '\n';
#else
                    fprintf (yyout, "try extended ccl on char ");
                    allprint(YYU(yywch));
                    putchar('\n');
#endif /* #if defined(__cplusplus) && defined(_CPP_IOSTREAMS) */
                }
# endif
                yyw = yyxlook(yywch,yystate-yysvec);
                if (yyw != -1)
                {
                    if (yyxccl[yyw].advance+yysvec == YYLERR)
                    {
                        wunput(*--yywlastch);
                        break;
                    }
                    *yytlsp++ = yystate = yyxccl[yyw].advance+yysvec;
                    goto contin;
                }
# endif /*YYXSIZE*/
            } /* r < yycrank */
            if ((yystate = yystate->yyother) && (yyt= yystate->yystoff) != yycrank)
            {
# ifdef LEXDEBUG
#if defined(__cplusplus) && defined(_CPP_IOSTREAMS)
                if(debug) (*yyout) << "fall back to state "
                                   << yystate-yysvec-1 << endl;
#else
                if(debug) fprintf(yyout,"fall back to state %d\n",yystate-yysvec-1);
#endif /* #if defined(__cplusplus) && defined(_CPP_IOSTREAMS) */
# endif
                goto tryagain;
            }
# endif /*YYOPTIM*/
            else
            {
                wunput(*--yywlastch);
                break;
            }
        contin:
# ifdef LEXDEBUG
            if(debug)
            {
#if defined(__cplusplus) && defined(_CPP_IOSTREAMS)
                (*yyout) << "state " << yystate-yysvec-1 << " char ";
                allprint(yywch);
                (*yyout) << endl;
#else
                fprintf(yyout,"state %d char ",yystate-yysvec-1);
                allprint(yywch);
                putchar('\n');
#endif /* #if defined(__cplusplus) && defined(_CPP_IOSTREAMS) */
            }
# endif
            ; /* contin: */
        } /* for(;;) */
# ifdef LEXDEBUG
        if(debug)
        {
#if defined(__cplusplus) && defined(_CPP_IOSTREAMS)
            (*yyout) << "stopped at " << (int) (*(yytlsp-1)-yysvec-1) << " with ";
            allprint(yywch);
            (*yyout) << endl;
#else
            fprintf(yyout,"stopped at %d with ",*(yytlsp-1)-yysvec-1);
            allprint(yywch);
            putchar('\n');
#endif /* #if defined(__cplusplus) && defined(_CPP_IOSTREAMS) */
        }
# endif
        while (yytlsp-- > yylstate)
        {
            *yywlastch-- = 0;
            if (*yytlsp != 0 && (yyfnd= (*yytlsp)->yystops) && *yyfnd > 0)
            {
                yyolsp = yytlsp;
                if(yyextra[*yyfnd])             /* must backup */
                {
                    while(yyback((*yytlsp)->yystops,-*yyfnd) != 1 && yytlsp > yylstate)
                    {
                        yytlsp--;
                        wunput(*yywlastch--);
                    }
                }
                yyprevious = YYU(*yywlastch);
                yylsp = yytlsp;
                yywleng = yywlastch-yywtext+1;
                yywtext[yywleng] = 0;
# ifdef LEXDEBUG
                if(debug)
                {
#if defined(__cplusplus) && defined(_CPP_IOSTREAMS)
                    (*yyout) << "\nmatch ";
                    sprint(yywtext);
                    (*yyout) << " action " << *yyfnd << endl;
#else
                    fprintf(yyout,"\nmatch ");
                    sprint(yywtext);
                    fprintf(yyout," action %d\n",*yyfnd);
#endif /* #if defined(__cplusplus) && defined(_CPP_IOSTREAMS) */
                }
# endif

                wreturn(*yyfnd++);
            }
            wunput(*yywlastch);
        }
        if (yywtext[0] == 0  /* && feof(yyin) */)
        {
            yysptr=yysbuf;
            wreturn(0);
        }
        yyprevious = yywtext[0] = winput();
        if (yyprevious>0)
            woutput(yyprevious);
        yywlastch=yywtext;
# ifdef LEXDEBUG
#if defined(__cplusplus) && defined(_CPP_IOSTREAMS)
        if(debug) cout << endl;
#else
        if(debug) putchar('\n');
#endif /* #if defined(__cplusplus) && defined(_CPP_IOSTREAMS) */
# endif
    } /* for (;;) */
    wreturn(0);
}
int yyback(int *yyp, int yym)
{
    if (yyp==0) return(0);
    while (*yyp)
    {
        if (*yyp++ == yym)
            return(1);
    }
    return(0);
}
# if YYHSIZE
/*
 * wide chars are hashed in yywcrank, return the index of the found element, or
 * zero
 */
int yyhlook(int yyc, int yyv)
{
int             yyn;

    yyn = (yyc % (YYHSIZE - 1)) + 1;
    for (;;)
    {
        if ((yywcrank[yyn].wch==yyc)&&(yywcrank[yyn].wverify==yyv))
            return(yyn);
        yyn = yywcrank[yyn].wnext;
        if (yyn==0)
            return(0);
    }
}
# endif /*YYHSIZE*/
# if YYHSIZE
/*
 * wide CCL chars are hashed in yywmatch, return the character to map to or
 * zero if there are none;  each char occurs only once in the match table.
 */
int
yymlook(int yyc)
{
# if YYMSIZE
int             yyn;

    yyn = (yyc % (YYMSIZE - 1)) + 1;

    while (yyn!=0)
    {
        if (yywmatch[yyn].wch == yyc)
            return(yywmatch[yyn].wmatch);
        yyn = yywmatch[yyn].wnext;
    }
# endif /*YYMSIZE*/

    return(0);
}
# endif /*YYHSIZE*/
# if YYXSIZE
/*
 * general CCLs are described in yyxccl; return the index of the first
 * acceptable CCL that matches verification, -1 if none found.
 */
int
yyxlook (int yyc, int yyv)
{
register int yyi;

    if (!yyc)                                     /* c==0 => EOF */
        return (-1);

    for (yyi = 0; (yyi < YYXSIZE) && (yyxccl[yyi].verify < yyv); yyi++)
        ; /*Empty*/

    for ( ; (yyi < YYXSIZE) && (yyxccl[yyi].verify == yyv); yyi++)
    {
        switch (yyxccl[yyi].type)
        {
        case YYCCLDOT:  return((yyc=='\n')?-1:yyi);
        }
    }
    return (-1);
}
#endif
/*
 * The following are the multi-byte renditions of input, unput, and
 * output.  They are referenced through the winput, wunput, and woutput macros
 * resepectively.
 *
 * A (-1) is returned if the character input is invalid.
 */
#ifdef __cplusplus
#include <mbstr.h>
#endif /*  __cplusplus */
int yywinput()
{
    yytbi=0;
    do
    {
        yytbuf[yytbi++]=input();
        yytbuf[yytbi]=0;
    } while(mbsinvalid((const char *) yytbuf)&&(yytbi<yymbcurmax));

    if (mbtowc(&yytwc,(const char *)yytbuf,yymbcurmax)<0)
        return (-1);

    return ((int)yytwc);
}

void yywoutput(int yyc)
{
    for (yytbi=wctomb((char *) yytbuf,(wchar_t)yyc),yytbp=yytbuf;yytbi>0;yytbi--)
        output(*yytbp++);
}
void yywunput(int yyc)
{
    for(yytbi=wctomb((char *)yytbuf,(wchar_t)yyc)-1;yytbi>=0;yytbi--)
        unput(yytbuf[yytbi]);
}
/*
 * Convert yywtext to yytext prior to returning from yylook.  It is referenced
 * through the wreturn macro.
 */
int yywreturn(int yyr)
{
    yyleng=wcstombs((char *)yytext,yywtext,YYLMAX);
    if(yyleng<0)
    {
        yyleng=0;
        yytext[0]=0;
    }
    return(yyr);
}
/*
 * the following are only used in the lex library
 */
int yyinput()
{
    return(input());
}
void yyoutput(int yyc)
{
    output(yyc);
}
void yyunput(int yyc)
{
    unput(yyc);
}
int yymbinput()
{
    return(winput());
}
void yymboutput(int yyc)
{
    woutput(yyc);
}
void yymbunput(int yyc)
{
    wunput(yyc);
}
int yymbreturn(int yyx)
{
    wreturn (yyx);
}
