/*error handling... by wzl Jan. 31
  format: error(errno,arg1,arg2,...)
  cur_bfnd show point to current checked bif node.
  rewritten by Zheng Gengbin
*/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#if defined(STDC_HEADERS) && (STDC_HEADERS==1)
#include <stdlib.h>
#include <string.h>
#else
#include <strings.h>
#endif

#include <stdio.h>
#include <varargs.h>

#ifndef NeXT
#  include <malloc.h>
#endif

#   include "typedef.h"
#   include "bif.h"
#   include "ll.h"
#   include "symb.h"

#include "defnodes.h"
#include "dep.h"
#include "dep_struct.h"
#include "tags.h"
#include "decl.h"

#include "exglobal.h"

char *err_msg[1000];

int  global_err=0;
extern int globeErr_g;

int init_errMsg()
{
	err_msg[10]="Illegal statment in there:%d .";
	err_msg[11]="Illegal statment in block:%d .";
	err_msg[12]="Illegal use statement here.";
	err_msg[13]="Illegal implicit statement here.";

/*	zheng.gb	*/
	err_msg[100]="Unkown type: %d .";
        err_msg[101]="Out of dimmenion when refer to array '%s'.";
        err_msg[102]="Should be Int !";
        err_msg[103]="Type mismatched in %s . ";
        err_msg[104]="Unknown type of expression ! ";
        err_msg[105]="Only Integer type allowed in scalar integer constant expression .";
        err_msg[106]="Illegal type ! ";
        err_msg[107]="Llnd variant %d Must have a  type ! ";
        err_msg[108]="HIT: lost symbol ! ";
        err_msg[109]="Variable: %s  nondeclared !";
        err_msg[110]="Variable: %s  should be declared as array type !";
	err_msg[111]="Variable: %s declared no type ! ";
        err_msg[112]="Inavlid record field '%s' ! ";
        err_msg[113]="Illegal assignment : rank not equal .";
        err_msg[114]="Inavlid constant L-value! ";
        err_msg[115]="Invalid vector subscipt of array %s ! ";
        err_msg[116]="Invalid subscipt type of array %s ! ";
        err_msg[117]="The subscript must match the rank of the variable !";
        err_msg[118]="More than one structure component have non-zero rank in %d_th part_ref .";
        err_msg[119]="Scalar parent string expected !";
        err_msg[120]="Character type expected !";
	err_msg[121]="Stride are ignored ! ";
        err_msg[122]="Scalar int substring range expected ! ";
        err_msg[123]="Illegal assignment ! rank not match ! .";
        err_msg[124]="Refer to the same variable in the different module ! ";
        err_msg[125]="In array section ,exactly one rank is allowed ! ";
        err_msg[126]="Too few arguments !";
        err_msg[127]="Module name not found ! ";
        err_msg[128]="The rightest part name of record :%s must be character .";
        err_msg[129]="Scalar int do variable '%s' expected in the implied do control.";
        err_msg[130]="Do variable expected in the implied do control.";
        err_msg[131]="Duplicate Do variable in the implied do control.";
        err_msg[132]="The values in the array constructor must have same type and kind parameter .";
        err_msg[133]="Duplicate subroutine: %s  decalred .";
        err_msg[134]="Symbol:%s can not be assigned value.";
        err_msg[135]="Variable  must have POINTER attribute .";
        err_msg[136]="Variable cannot be assigned a nonPOINTER value.";
        err_msg[137]="Pointer assignment must have same type ,kind parameter and rank .";
        err_msg[138]="Record type needed in structure construct of '%s'.";            
        err_msg[139]="Cannot enter a block from outside !";
        err_msg[140]="Variable: %s has IN attribute cannot be assigned !";
        err_msg[141]="The rank of the array in array constructor is more than once . ";
        err_msg[142]="Label : %d not defined .";
        err_msg[143]="Label : %d is  defined but never used .";
        err_msg[144]="Scalar logic expression expected in if statement . ";
        err_msg[145]="Illegal subscript triplet in array .";
        err_msg[146]="The if construct name  absents or does not or match .";
        err_msg[147]="The if construct name :%s of else_stmt exist while absent in if_stmt or end if stmt .";
        err_msg[148]="Type not match in assignment. ";
        err_msg[149]="Only scalar integer ,char or boolean type expression are allowed in select case stmt .";
        err_msg[150]="Case value range must have the same type as the case selector ."; 
        err_msg[151]="The select case construct name :%s of case_stmt exist while absent in select_stmt or end select stmt .";
        err_msg[152]="The select case  construct name absents or does not match .";
        err_msg[153]="The case value range of select case overlaped .";
        err_msg[154]="Cycle statement not in scope any of do construct ."; 
        err_msg[155]="Cycle statement not in scope of do construct name: %s."; 
        err_msg[156]="Exit statement not in scope any of do construct ."; 
        err_msg[157]="Exit statement not in scope of do construct name: %s."; 
        err_msg[158]="The case default selector occurs more than once in the select case construct statement .";
        err_msg[159]="Illegal use of case value range in logic expression .";
        err_msg[160]="The mask expression of where statement must be a array .";
        err_msg[161]="Logic expression expected in The mask expression of where statement .";
        err_msg[162]="Only assignment statement are allowed in where statement .";
        err_msg[163]="Do control variable must be a scalar named variable .";
        err_msg[164]="Do control variable can only be type of integer ,real or double ."; 
        err_msg[165]="The increment of Do loop control can only be type of integer ,real or double ."; 
        err_msg[166]="The range of Do loop control can only be type of integer ,real or double ."; 
	err_msg[167]="Illegal statement found in DO construct .";
	err_msg[168]="Label absent in end do statement .";
	err_msg[169]="The label of end do statement not match the do statement .";
	err_msg[170]="Label absent in continue statement .";
	err_msg[171]="The end of do structure must not be continue statement when beginning with nonlabel do statement .";
	err_msg[172]="The do construct name of end do statement absent or not match the do construct name of do statement '%s'.";
	err_msg[173]="The do construct that has do construct name cannot be ended with continue statement .";
	err_msg[174]="The statement is not branch target statement .";
	err_msg[175]="Cannot jump from one branch to the other in if statement.";
	err_msg[176]="Illegal branching to other block .";
	err_msg[177]="Initialization expression expected .";
	err_msg[178]="Scalar expression expected in computed goto statement .";
	err_msg[179]="Integer expression expected in computed goto statement .";
	err_msg[180]="Illegal label:%d branching to other block .";
	err_msg[181]="Variable instead of constant expected in assign to statement .";
	err_msg[182]="Scalar variable expected in assign to statement .";
	err_msg[183]="Variable:%s should be declared as integer type in assign to statement .";
	err_msg[184]="Scalar expression expected in arithmetic if statement .";
	err_msg[185]="Numeric expression expected in arithmetic if statement .";
	err_msg[186]="Variable:%s cannot be assumed size array .";
	err_msg[187]="Too many arguments in intrinsic function %s .";
	err_msg[188]="Scalar result of expression expected .";
	err_msg[189]="Type not match in intrinsic function call %s ";
	err_msg[190]="Only array of pointer or allocatable attributes can be allocated ."; 
	err_msg[191]="Initialization expression expected in array specification.";
	err_msg[192]="Constant expression expected in initialization expression .";
	err_msg[193]="Kind arguments must be same in // operation ."; 
	err_msg[194]="The component \'%s\' of derived type '%s' are private ,cannot be refered ."; 
	err_msg[195]="Derived type '%s' not declared or accessible ."; 
	err_msg[196]="Kind parameter can only be integer type ."; 
	err_msg[197]="Null constant expression encounted .";
	err_msg[198]="The field '%s' of record '%s' is pointer type .";
        err_msg[199]="The end select case construct name absents or does not match the construct name '%s'.";
	err_msg[200]="The conditional expression in do while statement must be scalar logical expression .";
	err_msg[201]="Illegal statement act as do termination shared statement .";
	err_msg[202]="Illegal statement act as do termination action statement .";
	err_msg[203]="Illegal specification expression .";
	err_msg[204]="Scalar expression expected in specification expression .";
	err_msg[205]="Integer expression expected in specification expression.";
	err_msg[206]="Derived type '%s' not declared .";
	err_msg[207]="Illegal assignment variable in PURE function or procedure .";
	err_msg[208]="Illegal DO variable or implied DO variable in PURE function or procedure .";
	err_msg[209]="Illegal pointer_object or target variable of pointer assignment statement in PURE function or procedure .";
	err_msg[210]="A pure function must not contain a STOP statement.";
	err_msg[211]="A pure function must not contain a PAUSE statement.";
	err_msg[212]="Any procedure referenced in a pure function or procedure must be pure.";
	err_msg[213]="The pointer object being nullified must have POINTER attribute .";
	err_msg[214]="Only array of pointer or allocatable attributes can be deallocated ."; 
	err_msg[215]="Illegal variable '%s' as an stat-variable in an allocate statement or deallocate statement .";
	err_msg[216]="Illegal variable '%s' as an allocate object in an allocate statement or deallocate statement .";
	err_msg[217]="Illegal action statement here in IF statement .";
	err_msg[218]="Action statement expected here in IF statement .";
	err_msg[219]="Stop code must be a scalar character constant .";
	err_msg[220]="Stop code must be a character constant .";
	err_msg[221]="Illegal label assignment variable in PURE function or procedure .";
	err_msg[222]="Different align dummy appeared in one expression .";
	err_msg[223]="Align-subscipt-use must be a linear funtion of a single occurence of an align dummy .";
	err_msg[224]="Align dummy '%s' must be of integer type .";
	err_msg[225]="%d_th align subscript in align with clause must be of integer type .";
	err_msg[226]="Mask expression in Forall statement must be logical type .";
	err_msg[227]="Mask expression in Forall statement must be scalar type .";
        err_msg[228]="Index name '%s' of Forall statement must  be of integer type .";
        err_msg[229]="Scalar int expression expected in the implied do control.";
        err_msg[230]="Illegal record reference of %s .";
        err_msg[231]="Variable '%s' must be constant .";
        err_msg[232]="Dummy variable '%s' be declared more than once .";
	err_msg[233]="Dummy variable '%s' cannot be used as an allocate object in an allocate statement or deallocate statement .";
	err_msg[234]="Assignment variable '%s' cannot be dummy in PURE function or procedure or Forall statement.";
	err_msg[235]="The type cannot be determined ! .";
	err_msg[236]="The kind parameter must be intialization expression .";
	err_msg[237]="The kind parameter must be scalar integer expression .";
	err_msg[238]="The kind parameter must be positive integer .";
	err_msg[239]="BOZ literal constant can only appear in DATA statement.";
	err_msg[240]="The derived type '%s' cannot be intrinsic type .";
	err_msg[241]="The %d_th field of structure constructor can not match the corresponding field in the record.";
	err_msg[242]="Duplicate dummy '%s'. ";
	err_msg[243]="Where assignment can not be defined assignment .";
	err_msg[244]="Any procedure refered in Forall must be defined as pure .";
	err_msg[245]="Any procedure refered in a PURE procedure must be defined as pure .";
	err_msg[246]="The number of fields of structure constructure do not match type '%s' .";  
	err_msg[247]="The shape argument must be a constant array in reshape.";
	err_msg[248]="Module '%s' have not be defined .";
	err_msg[249]="Illegal initialization  due to type incompatiable .";




/*	modified by WZL-LY, 3-12
        err_msg[301]="sub object can not be distributed";
        err_msg[302]="distributee should have INHERIT attribute";
        err_msg[303]="dimensions of distributee should equal to that of processors here";
        err_msg[304]="dist_format should contain int expression";
        err_msg[305]="variable %s's dist_format dims not consistent with decl";
        err_msg[306]="variable %s's distributed dims not equal to processor %s's dims";
*/
        err_msg[301]="var %s is subobject and can not be distributed";
        err_msg[302]="var %s should have INHERIT attribute";
 	err_msg[303]="dimensions of distributee should equal to that of processors here",
      	err_msg[304]="dist_format should contain int expression";
        err_msg[305]="var %s dist_format dims not consistent with decl";
        err_msg[306]="distributed dims not equal to processor %s dims";
        err_msg[307]="alignee %s can not be distributed";
        err_msg[308]="%s should be dummy_arguments";
        err_msg[309]="%s should not have both ALIGN and INHERIT attributes";
        err_msg[310]="illegal star";
        err_msg[311]="%s should have DYNAMIC attribute";
        err_msg[312]="%s align_source dims should equal to decl dims";
        err_msg[313]="%s can not explicitely map(not cover)";
        err_msg[314]="%s is multi_dim array and can not explicitely map";
        err_msg[315]="%s distribution result in splitting %s";
/*  	WZL-LY, 03-12	*/
/*      LY, check PURE function 	*/
        err_msg[320]="variable in PURE function can not have INHERIT attribute";
        err_msg[321]="local variable in PURE function can not have DYNAMIC attribute";
        err_msg[323]="local variable '%s' in PURE function has invalid align target";
        err_msg[324]="local variable '%s' in PURE function can not distributed";
        err_msg[325]="REALIGN and REDISTRIBUTE can not appear in PURE function";
/*	LY	*/



	/* by Feng Xiaobing */
	err_msg[400]="variable redeclaration";
	err_msg[401]="only one appearance of \'%s\' is permitted in all common block within a scoping unit";
	err_msg[402]="\'%s\' must not be a dummy argument";
	err_msg[403]="\'%s\' must not be an allocatable array";
	err_msg[404]="\'%s\' must not be an automatic object";
	err_msg[405]="\'%s\' must not be a function name";
	err_msg[406]="\'%s\' must not be an entry name";
	err_msg[407]="\'%s\' must not be a result name";
	err_msg[408]="each bound of \'%s\' must be a constant speification expression";
	err_msg[409]="the derived type of \'%s\' must be a sequence type";
	err_msg[410]="\'%s\' must not have the POINTER attribute";
	err_msg[411]="common object must be an variable name";
	err_msg[412]="variable \'%s\' can not be a variable accessible by use or host association";
	err_msg[413]="constant \'%s\' can not be defined more than once";
	err_msg[414]="constant \'%s\' must have a constant initialization expression";
	err_msg[415]="array \'%s\' can not appear in equivalence statement";
	err_msg[416]="attempt to extend common block %s backward";
	err_msg[417]="save statement misappear";
	err_msg[418]="common object \'%s\' can not have SAVE attribute";
	err_msg[419]="\'%s\' can not have PARAMETER attribute";
	err_msg[420]="save object \'%s\' can not be a procedure name";
	err_msg[421]="\'%s\' can not be a function name";
	err_msg[422]="\'%s\' can not be a const";
	err_msg[423]="\'%s\' can not be an entry name";
	err_msg[424]="INTENT statement misplaced";
	err_msg[425]="\'%s\' should be a dummy";
	err_msg[426]="\'%s\' must not be a name of dummy procedure";
	err_msg[427]="OPTIONAL statement misplaced";
	err_msg[428]="\'%s\' should be a deferred shape array";
	err_msg[429]="\'%s\' can not have a INTENT attribute";
	err_msg[430]="empty access statement misplaced";
	err_msg[431]="redeclarate the derived type \'%s\'";
	err_msg[432]="PRIVATE statement misplaced";
	err_msg[433]="SEQUENCE statement misplaced";
	err_msg[434]="POINTER attribute can not appear more than once";
	err_msg[435]="DIMENSION attribute can not appear more than once";
	err_msg[436]="There must have POINTER attribute if is declared as the type which is being defined .";
	err_msg[437]="type of this statement should be a sequence derived type";
	err_msg[438]="array specification error";
	err_msg[439]="the * char_length option is not permitted";
	err_msg[440]="objects which belong to different common block can not appear in same equivalence: %s , %s";
	err_msg[441]="equivalence statement can not make common object \'%s\' has different common block offset";
	err_msg[442]="range of \'%s\' error";
	err_msg[443]="attribute specification error";
	err_msg[444]="variable with parameter attribute (\'%s\') must initilization";
	err_msg[445]="\'%s\' should be an array";
	err_msg[446]="\'%s\' should be an function name";
	err_msg[447]="\'%s\' can not have SAVE attribute";
	err_msg[448]="\'%s\' should be a dummy";
	err_msg[449]="\'%s\' can not appear more than once in a SEQUENCE directive";
	err_msg[450]="\'%s\' can not have SEQUENCE directive attribute";
	err_msg[451]="IMPLICIT NONE statement misplaced";
	err_msg[452]="\'%s\' can not have PRIVATE attribute";
	err_msg[453]="\'%s\' can not have ALLOCATABLE attribute";
	err_msg[454]="\'%s\' must be a character variable";
	err_msg[455]="if the minus and second letter appear in a implicit statement, the second letter must follow the first letter alphabetically.";
	err_msg[456]="there is a IMPLICIT NONE statement in this scope, this implicit statement is illeagal";
	err_msg[457]="\'%s\' can not have TARGET attribute";
	err_msg[458]="\'%s\' can not be initialized";
	err_msg[459]="common object \'%s\' can not appear here";
	err_msg[460]="dummy \'%s\' should be specificated the intent attribute";
	err_msg[461]="external statement can not appear in a block data unit";
	err_msg[462]="intrinsic statement can not appear in a block data unit";
	err_msg[463]="sequence statement can not appear in a block data unit";
	err_msg[464]="no sequence statement can not appear in a block data unit";
	err_msg[465]="intent statement can not appear in a block data unit";
	err_msg[466]="optional statement can not appear in a block data unit";
	err_msg[467]="access statement can not appear in a block data unit";
	err_msg[468]="allocatable statement can not appear in a block data unit";
	err_msg[469]="common block \'%s\' in each program unit must have the same size";
	err_msg[470]="common block \'%s\' in each program unit must have the same attribute";
	err_msg[471]="common block \'%s\' in each program unit must have the same shape";
	err_msg[472]="The %d_th DATA statement repeat must be scalar int constant.";
	err_msg[473]="The %d_th DATA statement value must be constant.";
	err_msg[474]="The length of character '%s' must be a constant specification expression";
	err_msg[475]="Illegal function name :'%s'. ";
	err_msg[476]="Initialization of '%s' must appear .";
	err_msg[477]="\'%s\' can not be initialized more than once";
	err_msg[478]="component of a sequential derived type must be a sequential type";
	err_msg[479]="Access statement can only appear in MODULE .";
	err_msg[480]="Assumed size array '%s' must be declared as a dummy .";
	err_msg[481]="Assumed shape array '%s' must be declared as a dummy .";
	



	/*by Yanmi*/
	err_msg[501]="subprogram %s  must be FUNCTION!";
	err_msg[502]="%s argument number isnot consistant with intrinsic operator";
	err_msg[503]="variable %s caannot be OPTIONAL";
	err_msg[504]="variable %s must be INTENT(IN)";
	err_msg[505]="subprogram %s must be SUBROUTINE";
	err_msg[506]="subroutine %s need 2 arguments";
	err_msg[507]="variable %s  must be INTENT(OUT) or INTENT(INOUT)";
	err_msg[508]="interface statement cannot appear in blockdat";
	err_msg[509]="subprogram mismatched";
	err_msg[510]="subprogram %s and %s cannot be distinguished";
	err_msg[511]="module procedure statements can not appear in interface";
	err_msg[512]=" %s must be in interface with interface name";
	err_msg[513]="%s is not subprogram";
	err_msg[514]="%s is not defined in module";
	err_msg[515]="%s is  not accessible";
	err_msg[516]="%s cannot be both EXTERNAL and INTRINSIC";
	err_msg[517]="entry %s cannot be EXTERNAL";
	err_msg[518]="illegal prefix";
	err_msg[519]="function %s and result %s cannot be duplicated";
	err_msg[520]="function %s and result %s type mismatched";
	err_msg[521]="dummy %s in PURE subprogram cannot be POINTER";
	err_msg[522]="entry statment misplaced";
	err_msg[523]="entry astatement with result cannot appear in function";
	err_msg[524]=" * cannot appear in function as dummy";
	err_msg[525]="entry %s and function %s mismatched";
	err_msg[526]="return can only appear in subprogram";
	err_msg[527]="return with expression can only appear in subroutine";
	err_msg[528]="contains misplaced";
	err_msg[529]="stmt function misplaced";
	err_msg[530]="%s in stmt_function_stmt cannot be array";
	err_msg[531]=" %s has been declared EXTERNAL or INTRINSIC more than once";
	err_msg[532]="interface name %s redeclared";
	err_msg[533]="dummy name %s cannot be EXTERNAL";
	err_msg[534]="dummy name %s in PURE subprogram cannot be EXTERNAL";
	err_msg[535]="assignment cannot be changed into stm_function_Stmt";
	err_msg[536]="expression in stmt_function_stmt must be scalar";
	err_msg[537]="Duplicate declared symbol : %s ";
	err_msg[538]="module procedure %s isnot accessible";
	err_msg[539]="%s cannot be used as function";
	err_msg[540]="%s cannot be used as subroutine";
	err_msg[541]="can not find the special name of generic '%s'";
	err_msg[542]="subprogram name '%s' need explicit inteface";
	err_msg[543]="the %d_th actual argument has no corresponding dummy argument in procedure '%s'. ";
	err_msg[544]="non_optional dummy %s in subprogram %s hasnot been associated with actual arg";
	err_msg[545]="too many actual arguments associate with dummy %s";
	err_msg[546]="the %d_th actual argument need dummy keyword";
	err_msg[547]="actual arg %s need be function";
	err_msg[548]="actual argument %s associated with dummy procedure, need to be EXTERNAL,INTRINSIC or defined in interface";
	err_msg[549]="actual arg %s need be subroutine";
	err_msg[550]="the %d th actual arg cannot be expression";
	err_msg[551]="the %d th actual arg need to be Label";
	err_msg[552]="label isnot valid";
	err_msg[553]="the %d  actual arg cannot be assumed size array"; 
	err_msg[554]="the %d  actual arg need has POINTER attribute";
	err_msg[555]="the %d  actual arg has mismatched intent attribute";
	err_msg[556]="the %d  actual arg and dummy '%s' haveno matched type";
	err_msg[557]="the %d  actual arg and dummy '%s' :derived type mismatched";
	err_msg[558]="the %d  actual arg :derived type must be SEQUENCE";
	err_msg[559]="dummy %s :derived type must be SEQUENCE";
	err_msg[560]="the %d  actual arg: component of derived %s and %s are mismatched";
        err_msg[561]="the %d  actual arg: component of derived %s and %s have mismatched attribute";
	err_msg[562]="dummy %s : component of derived type %s must be PRIVATE";
        err_msg[563]="the %d  actual arg : component of derived type %s must be PRIVATE";
	err_msg[564]="the  %d actual arg must be array";
	err_msg[565]="the %d  actual arg and dummy %s :base type mismatched";
	err_msg[566]="the %d  actual arg and dummy %s: rank mismatched";
	err_msg[567]="warning error : too many module";
	err_msg[568]="fatal error:  module %s is used recursivelly";
	err_msg[569]="the %d actual arg can't find its correspoding dummy";
	err_msg[570]="warning error : too many subprogram";
	err_msg[571]="fatal error:  subprogram %s is called recursivelly,need keyword RECURSIVE";

	err_msg[572]="program name %s is redecalred";
	err_msg[573]="module  name %s is redecalred";
	err_msg[574]="the %d actual arg need be variable name";

	err_msg[580]="cannot omit keyword";
	err_msg[581]="keyword %s is duplicate";
	err_msg[582]="keyword '%s' : type mismatched with grammar";
	err_msg[583]="keyword \"%s\" need  a label expr";
	err_msg[584]="label is undefined or invalid used";
	err_msg[585]="inquire stmt must include keyword \"unit\" or \"file\"";
	err_msg[586]=" io specification must include keyword \"unit\"";
	err_msg[587]="keyword  cannot be omitted";
	err_msg[588]="in read statment or write_stmt: \"nml\" and \"fmt\" cannot both appear ";
	err_msg[589]="in read_stmt or write_smt:if \"rec\" appear ,\"end\" or \"nml\" cannot appear";
	err_msg[590]="in read_stmt or write_smt: if \"eor\" appear, \"advance\" must appear too";
	err_msg[591]="in read_stmt or write_smt:\"advance\"  can only appear when explicit format appear";
	err_msg[592]="io keyword \"nml\" need be followed by a namelist variable";
	err_msg[593]="io  keyword \"fmt\" : expression isnot matched";
	err_msg[594]="in io statment: format can omly be integer when it is a variable";
	err_msg[595]="Function or Subroutine '%s' not declared .";
	err_msg[596]="the %d th actual arg cannot be label";
	err_msg[597]="the %d_th actual argument has no corresponding dummy argument in intrinsic procedure '%s'. ";
	err_msg[598]="Cannot find the proper intrinsic procedure call '%s'.";
	err_msg[599]="Entry '%s' declared no type .";


}

				/*  error(err_code)   */
void  error1(no)
int  no;
{
	char *fmt;

	(void)fprintf(stderr,"hpfsc: line %d error %d:",cur_bfnd->g_line,no);
	fmt = err_msg[no];

	/* print out remainder of message */
	(void)fprintf(stderr, fmt); 
	(void)fprintf(stderr,"\n");
	globeErr_g++;
}

				/*  error(err_code,int)   */
void  error2(no,data)
int  no,data;
{
	char *fmt;

	(void)fprintf(stderr,"hpfsc: line %d error %d:",cur_bfnd->g_line,no);
	fmt = err_msg[no];

	/* print out remainder of message */
	(void)fprintf(stderr, fmt, data); 
	(void)fprintf(stderr,"\n");
	globeErr_g++;
}

				/*  error(err_code,char *)   */
void  error3(no,data)
int  no;
char *data;
{
	char *fmt;

	(void)fprintf(stderr,"hpfsc: line %d error %d:",cur_bfnd->g_line,no);
	fmt = err_msg[no];

	/* print out remainder of message */
	(void)fprintf(stderr, fmt, data); 
	(void)fprintf(stderr,"\n");
	globeErr_g++;
}

				/*  error(err_code,char *, char *)   */
void  error4(no,data1,data2)
int  no;
char *data1, *data2;
{
	char *fmt;

	(void)fprintf(stderr,"hpfsc: line %d error %d:",cur_bfnd->g_line,no);
	fmt = err_msg[no];

	/* print out remainder of message */
	(void)fprintf(stderr, fmt, data1,data2); 
	(void)fprintf(stderr,"\n");
	globeErr_g++;
}

				/*  error(err_code,int , char *)   */
void  error5(no,data1,data2)
int  no;
int   data1;
char *data2;
{
	char *fmt;

	(void)fprintf(stderr,"hpfsc: line %d error %d:",cur_bfnd->g_line,no);
	fmt = err_msg[no];

	/* print out remainder of message */
	(void)fprintf(stderr, fmt, data1,data2); 
	(void)fprintf(stderr,"\n");
	globeErr_g++;
}

				/*  error(err_code,int ,char *, char *)   */
void  error6(no,data1,data2,data3)
int  no;
int   data1;
char *data2,*data3;
{
	char *fmt;

	(void)fprintf(stderr,"hpfsc: line %d error %d:",cur_bfnd->g_line,no);
	fmt = err_msg[no];

	/* print out remainder of message */
	(void)fprintf(stderr, fmt, data1,data2,data3); 
	(void)fprintf(stderr,"\n");
	globeErr_g++;
}

/*
int  error(no,va_alist)
*/
       /* Note that the function_name and format arguments cannot be
        *      separately declared because of the definition of varargs.
        */
/*
int  no;
       va_dcl
       {
            va_list args;
            char *fmt,str[256];

            va_start(args);
*/
       /*     no = va_arg(args, int); */
            /* print out name of function causing error */
/*
	    (void)fprintf(stderr,"hpfsc: line %d error %d:",cur_bfnd->g_line,no);

            fmt = err_msg[no];
*/
            /* print out remainder of message */
/*
            (void)vfprintf(stderr, fmt, args); 

            (void)fprintf(stderr,"\n");

	    global_err ++;

            va_end(args);
       }
*/

/*
void  warn(no,va_alist)
int no;
       va_dcl
       {
            va_list args;
            char *fmt;

            va_start(args);

	    (void)fprintf(stderr,"hpfsc: line %d warning %d:",cur_bfnd->g_line,no);

            fmt = err_msg[no];

            (void)vfprintf(stderr, fmt, args);

            (void)fprintf(stderr,"\n");

            va_end(args);
       }
*/

void  warn1(no)
int  no;
{
        char *fmt;

        (void)fprintf(stderr,"hpfsc: line %d warning %d:",cur_bfnd->g_line,no);
        fmt = err_msg[no];

        /* print out remainder of message */
        (void)fprintf(stderr, fmt);
        (void)fprintf(stderr,"\n");
}

void  warn2(no,data)
int  no,data;
{
        char *fmt;

        (void)fprintf(stderr,"hpfsc: line %d warning %d:",cur_bfnd->g_line,no);
        fmt = err_msg[no];

        /* print out remainder of message */
        (void)fprintf(stderr, fmt, data);
        (void)fprintf(stderr,"\n");
}

