/****************************************************************
 *      Macro Defination	   Lxy.  (12/30/1995)		*
 ****************************************************************/

#define ALLOC(x)  (struct x *) chkalloc(sizeof(struct x))

#define BFNULL          (PTR_BFND) 0
#define LLNULL          (PTR_LLND) 0
#define BLNULL          (PTR_BLOB) 0
#define SMNULL          (PTR_SYMB) 0
#define HSNULL          (PTR_HASH) 0
#define TYNULL          (PTR_TYPE) 0
#define LBNULL          (PTR_LABEL)0
#define CMNULL          (PTR_CMNT)0

/*******************************************************************
*   Macro Defination about common block and equivalence statement  *
*                   added by Feng Xiaobing                         *
*******************************************************************/

#define CNTNULL		(PTR_CNT) 0
#define CMLNULL 	(PTR_CML) 0
#define EQNULL		(PTR_EQ_LINK) 0
#define MRNULL		(PTR_MR_LINK) 0


/***********************  Attribute Bit  ***************************
*  The following 16 different options are used to declare variables
*  are as follows:
*               ( stored in symptr->attr )
********************************************************************/

#define ALLOCATABLE_BIT         1
#define DIMENSION_BIT           2
#define EXTERNAL_BIT            8
#define IN_BIT                  16
#define INOUT_BIT               32
#define INTRINSIC_BIT           64
#define OPTIONAL_BIT            128
#define OUT_BIT                 256
#define PARAMETER_BIT           512
#define POINTER_BIT             1024
#define PRIVATE_BIT             2048
#define PUBLIC_BIT              4096
#define SAVE_BIT                8192
#define SEQUENCE_BIT            16384
#define RECURSIVE_BIT           32768
#define TARGET_BIT              65536
#define DISTRIBUTE_BIT          131072
#define ALIGN_BIT               262144 
#define INHERIT_BIT             524288
#define DYNAMIC_BIT            1048576 

/*the followiing attr_bit added by Yanmi*/
#define	INTERFACE_BIT		2097152
#define	PURE_BIT		 4194304
#define	EXTRINSIC_HPF_BIT	8388608
#define	EXTRINSIC_HPFLOCAL_BIT	16777216
#define ENTRY_BIT		67108864         /* also check_expr_type */
#define	DEFINED_OPERATOR_BIT	134217728        /* also count binary flag */
#define	DEFINED_ASSIGNMENT_BIT	268435456       /* also check_leaf_symb flag */

#define PROCESSORS_BIT          33554432  /*modified by Yanmi*/
#define COVER_BIT		1073741824 /* modified by Feng Xiaobing */
#define DATA_BIT		4194304 /* modified by Feng Xiaobing */
#define NOSEQUENCE_BIT	        536870912 /*modified by Feng Xiaobing zheng.gb*/

/*
 *   The number of function or subroutine used in a file. Lxy.
 */
#define FUNC_SUB_NUM      100

/* 
 *   Macro_defination used in AST construction.  Lxy. 
 */

#define HARD                    1
#define SOFT                    0
#define NON         		0
#define YES        		1

#define STR_LENGTH 0x400                /* add by HIT */


#define hashMax                 1007
#define  NULL_UNIT_HEAD  "~~NULL_HEAD"
